var hauteur_div_resultats = 0;

function product_avatar(id_utilisateur, link_image) {
    document.getElementById('avatar_product_id').value = id_utilisateur;
    link_image = link_image.replace(".jpg", "_full.jpg");
    document.getElementById('image_full').setAttribute("src", link_image);
}

function imprimer() {

    var Table = document.getElementById('userProducts');
    if (Table === null) {
        alert('Aucunes données, veuillez renouveler.');
        return 0;
    } else {
        var doc = new jsPDF("");
        var pageHeight = doc.internal.pageSize.height;

        doc.setFontSize(10); //Points

        var date = new Date();
        var dd = date.getDate();
        var mm = date.getMonth() + 1;
        var yyyy = date.getFullYear();
        var hh = date.getHours();
        var mi = date.getMinutes();
        if (dd < 10)
        {
            dd = '0' + dd;
        }
        if (mm < 10)
        {
            mm = '0' + mm;
        }
        if (hh < 10)
        {
            hh = '0' + hh;
        }
        if (mi < 10)
        {
            mi = '0' + mi;
        }


        var ddmmyyyyhhmi = dd + '/' + mm + '/' + yyyy + ' ' + hh + ':' + mi + '';
        var ddmmyyyy = dd + '/' + mm + '/' + yyyy;
        doc.text('Réassort des produits du ' + ddmmyyyy, 20, 20);

        var x = 20;
        var y = 30;

        var longueurLigneTable = Table.rows.length;

        //Parcourir le tableau HTML de résultats
        for (i = 1; i < longueurLigneTable; i++) {
            var celluleTable = Table.rows.item(i).cells;
            var longueurCelluleTable = celluleTable.length;
            var valeurCelulleTable = celluleTable.item(0).innerHTML;
            //On affiche uniquement que les lignes sélectionnées
            if (document.getElementById("liste_products_" + valeurCelulleTable).checked) {
                //Récupérer valeurs et saisir dans PDF
                //Image

                var logo = document.createElement('canvas');
                var img = celluleTable.item(3).getElementsByTagName("img")[0];
                logo.height = img.naturalHeight;
                logo.width = img.naturalWidth;
                var ctx = logo.getContext('2d');
                ctx.drawImage(img, 0, 0, logo.width, logo.height);
                var base64String = logo.toDataURL();
                doc.addImage(base64String, 'PNG', x, y, 37.5, 50);
                y = y + 5;

                //Date
                x = x + 60;
                
                var valeurCelulleTable = celluleTable.item(2).innerText;
                doc.text('Date: ' + valeurCelulleTable, x, y);

                y = y + 5;
                //Référence
                var valeurCelulleTable = celluleTable.item(4).innerText;
                doc.text('Désignation: ' + valeurCelulleTable, x, y);

                y = y + 5;
                //Désignation
                var valeurCelulleTable = celluleTable.item(5).innerText;
                doc.text('Référence: ' + valeurCelulleTable, x, y);

                y = y + 5;
                //Coloris
                var valeurCelulleTable = celluleTable.item(6).innerText;
                doc.text('Couleur: ' + valeurCelulleTable, x, y);
                y = y + 5;
                //Codebarre
                var valeurCelulleTable = celluleTable.item(7).innerText;
                doc.text('Code-128/EAN8/EAN13: ' + valeurCelulleTable, x, y);
                //x = x + 45;
                y = y + 5;
                //Quantité
                var valeurCelulleTable = celluleTable.item(8).innerText;
                doc.text('Quantité: ' + valeurCelulleTable, x, y);
                //x = x + 30;
                y = y + 5;
                //TM
                var valeurCelulleTable = celluleTable.item(9).innerText;
                doc.text('TM: ' + valeurCelulleTable, x, y);
                //x = x + 30;
                y = y + 5;
                //Informations
                //Convertir en chinois
                //doc.setFont('NotoSansCJKjp');
                var valeurCelulleTable = celluleTable.item(10).innerText;
                doc.text('Informations: ', x, y);
                x = 102;
                var string = valeurCelulleTable.split(/(\s+)/);
                var cpt=0;
                var toDisplay = '';
                for (var k = 0; k < string.length; k++) {
                    if (y >= pageHeight - 20)
                    {
                        doc.addPage();
                        y = 10;
                    }
                    toDisplay += ''+string[k];
                    if (toDisplay.length >= 40) {
                        doc.text(toDisplay, x, y);
                        y = y + 5;
                        toDisplay = '';
                        x = 101;
                    }
                }
                if (toDisplay.length < 40) {
                    doc.text(toDisplay, x, y);
                    toDisplay = '';
                    if (string.length > 40) {
                      x = 101;
                    }
                }
                //x = x + 50;

                //Passage à la ligne
                y = y + 25;
                if (y > 244) {
                    y = y + 60;
                }
                x = 20;

                //Passage à la page suivante
                if (y >= pageHeight - 20)
                {
                    doc.addPage();
                    y = 10;
                }
            }
        }

        //Enregistrement
        doc.output('save', 'reassort_produits.pdf');
    }
}


function myPromise() {
    return new Promise((resolve, reject) => {
        setTimeout(() => {
            imprimer();
            resolve('');
            // reject('Some Error')
        }, 10000);
    });
}

function showSpinner() {
    $("#patienter").show();

}

function hideSpinner() {
    $("#patienter").hide();

}

async function imprimer_reassort() {
    try {
        showSpinner()
        const externalFetchedText = await myPromise();
    } catch (err) {
        console.error(err);
    } finally {
        hideSpinner()
    }
}









function refresh_products(force) {

    //Loader
    $('#refreshed_products').html('<span class="please_wait">Veuillez patienter...</span>');

    //hauteur_div_resultats = $(".content-wrapper").height() - 220;
    //$("#refreshed_products").height(hauteur_div_resultats);
    cpt = 0;

    $('input:checked[name=liste_products]').each(function () {
        cpt += 1;
    });
    if (cpt === 0 || force === "oui") {
        $.post("inc/resultatsReassort.php", {recherche: $("#recherche").val()})
                .done(function (data) {
                    $('#refreshed_products').html(data);
                })
                .fail(function () {
                });
    }
}

function toggle(source) {
    var checkboxes = document.querySelectorAll('input[name="liste_products"]');
    for (var i = 0; i < checkboxes.length; i++) {
        if (checkboxes[i] != source)
            checkboxes[i].checked = source.checked;
    }
}


$(document).ready(function () {

    refresh_products();

    $(".check_all_products").click(function () {
        $(".liste_products").prop("checked", $(this).prop("checked"));
    });

    $("#recherche").keyup(function () {
        if ($("#recherche").val != '') {
            mode_edition = "oui";
        } else {
            mode_edition = "non";
        }
        refresh_products();
    });


    $('#userProducts thead tr:eq(1) th').each(function (i) {
        //if (cpt !== 5) {
        //	$(this).html( '' );
        //} else {

        var title = $(this).text();
        $(this).html('<input type="text" placeholder="Rech..." />');

        $('input', this).on('keyup change', function () {
            if (i === 4) {
                if (table.column(i).search() !== this.value) {
                    table
                            .column(i)
                            .search("<span class=\"tabledit-span\">" + this.value + ".*<\/span>", true, false)
                            .draw();
                }

            } else {
                if (table.column(i).search() !== this.value) {
                    table
                            .column(i)
                            .search(this.value)
                            .draw();
                }
            }

        });
    });

    $(".scroll_y").on("scroll", function () {
        $("div:not(this)").scrollLeft($(this).scrollLeft());
    });
});
