package fr.itsee.zelyx;

import android.Manifest;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.os.AsyncTask;
import android.os.Bundle;
import android.provider.Settings;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.util.Base64;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.ByteArrayOutputStream;
import java.util.HashMap;
import java.util.Map;


/* ZEBRA */
/*public class AjouterProduitActivity extends AppCompatActivity implements EMDKListener, DataListener, StatusListener, ScannerConnectionListener, CompoundButton.OnCheckedChangeListener {*/
public class AjouterProduitActivity extends AppCompatActivity {

    private static final int CAMERA_REQUEST = 1888;
    private static final int MY_CAMERA_PERMISSION_CODE = 100;
    private static final int IMAGE_REQUEST = 1;
    public static String[] listeAllMarqueProduits;
    public static String[] listeAllCategorieProduits;
    public static String[] listeAllCouleursProduits;
    private static String imageProduitBase64;
    public Spinner listeMarqueProduit;
    public Spinner listeCategorieProduit;
    public Spinner listeCouleursProduit;
    String imageFilePath = "";
    String currentImagePath;
    String textProductCategorie, textProductReference, textProductColor, textProductPrice, textProductStock, textProductAncienneReference, textProductPricePromo, textProductQuantityPack, textProductMarque, textProductNumRayon, textProductTM;
    Spinner productCategorie, productMarque, productCouleurs;
    EditText productReference;
    EditText productPrice;
    EditText productStock;
    EditText productAncienneReference;
    EditText productPricePromo;
    EditText productQuantityPack;
    EditText productTM;
    EditText productNumRayon;
    Button bouttonAjouterProduit;
    private Button imageView;

    public Integer retourAjoutProduit = 0;

    public String getBase64ImageStringFromBitmap(Bitmap bitmap) {
        ByteArrayOutputStream stream = new ByteArrayOutputStream();
        bitmap.compress(Bitmap.CompressFormat.JPEG, 100, stream);
        byte[] byteFormat = stream.toByteArray();
        // get the base 64 string
        String imgString = Base64.encodeToString(byteFormat, Base64.NO_WRAP);

        return imgString;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_ajouter_produit);

           if (android.provider.Settings.System.getInt(getContentResolver(),
                    Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
                setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
            } else {
                setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
            }

        //Rafraîchir la liste déroulante des marques
        new GetAllMarqueProduitsAsyncTask().execute();
        //Rafraîchir la liste déroulante des catégories
        new GetAllCategorieProduitsAsyncTask().execute();
        //Rafraîchir la liste déroulante des couleurs
        new GetAllColorisProduitsAsyncTask().execute();

        productMarque = findViewById(R.id.marqueProduit);
        productCategorie = findViewById(R.id.categorieProduit);
        productReference = findViewById(R.id.referenceProduit);
        productCouleurs = findViewById(R.id.colorisProduit);
        productAncienneReference = findViewById(R.id.ancienneReferenceProduit);
        productTM = findViewById(R.id.TMProduit);
        productPrice = findViewById(R.id.prixProduit);
        productPricePromo = findViewById(R.id.prixPromoProduit);
        productQuantityPack = findViewById(R.id.quantitePackProduit);
        productStock = findViewById(R.id.stockProduit);
        productNumRayon = findViewById(R.id.numRayonProduit);


        //Naviguer de champs en champs
        productReference.setOnKeyListener(new View.OnKeyListener() {

            public boolean onKey(View v, int keyCode, KeyEvent event) {
                // If the event is a key-down event on the "enter" button
                if ((event.getAction() == KeyEvent.ACTION_DOWN) &&
                        (keyCode == KeyEvent.KEYCODE_ENTER)) {
                    // Perform action on Enter key press
                    productCouleurs.requestFocus();
                    return true;
                }
                return false;
            }
        });

        productCouleurs.setOnKeyListener(new View.OnKeyListener() {

            public boolean onKey(View v, int keyCode, KeyEvent event) {
                // If the event is a key-down event on the "enter" button
                if ((event.getAction() == KeyEvent.ACTION_DOWN) &&
                        (keyCode == KeyEvent.KEYCODE_ENTER)) {
                    // Perform action on Enter key press
                    productAncienneReference.requestFocus();
                    return true;
                }
                return false;
            }
        });

        productAncienneReference.setOnKeyListener(new View.OnKeyListener() {

            public boolean onKey(View v, int keyCode, KeyEvent event) {
                // If the event is a key-down event on the "enter" button
                if ((event.getAction() == KeyEvent.ACTION_DOWN) &&
                        (keyCode == KeyEvent.KEYCODE_ENTER)) {
                    // Perform action on Enter key press
                    productPrice.requestFocus();
                    return true;
                }
                return false;
            }

        });

        productPrice.setOnKeyListener(new View.OnKeyListener() {

            public boolean onKey(View v, int keyCode, KeyEvent event) {
                // If the event is a key-down event on the "enter" button
                if ((event.getAction() == KeyEvent.ACTION_DOWN) &&
                        (keyCode == KeyEvent.KEYCODE_ENTER)) {
                    // Perform action on Enter key press
                    productPricePromo.requestFocus();
                    return true;
                }
                return false;
            }
        });

        productPricePromo.setOnKeyListener(new View.OnKeyListener() {

            public boolean onKey(View v, int keyCode, KeyEvent event) {
                // If the event is a key-down event on the "enter" button
                if ((event.getAction() == KeyEvent.ACTION_DOWN) &&
                        (keyCode == KeyEvent.KEYCODE_ENTER)) {
                    // Perform action on Enter key press
                    productQuantityPack.requestFocus();
                    return true;
                }
                return false;
            }
        });

        productQuantityPack.setOnKeyListener(new View.OnKeyListener() {

            public boolean onKey(View v, int keyCode, KeyEvent event) {
                // If the event is a key-down event on the "enter" button
                if ((event.getAction() == KeyEvent.ACTION_DOWN) &&
                        (keyCode == KeyEvent.KEYCODE_ENTER)) {
                    // Perform action on Enter key press
                    productStock.requestFocus();
                    return true;
                }
                return false;
            }
        });

        productStock.setOnKeyListener(new View.OnKeyListener() {

            public boolean onKey(View v, int keyCode, KeyEvent event) {
                // If the event is a key-down event on the "enter" button
                if ((event.getAction() == KeyEvent.ACTION_DOWN) &&
                        (keyCode == KeyEvent.KEYCODE_ENTER)) {
                    // Perform action on Enter key press
                    productNumRayon.requestFocus();
                    return true;
                }
                return false;
            }
        });

        productNumRayon.setOnKeyListener(new View.OnKeyListener() {

            public boolean onKey(View v, int keyCode, KeyEvent event) {
                // If the event is a key-down event on the "enter" button
                return (event.getAction() == KeyEvent.ACTION_DOWN) &&
                        (keyCode == KeyEvent.KEYCODE_ENTER);
            }
        });

        this.imageView = this.findViewById(R.id.imageView);
        imageView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (checkSelfPermission(Manifest.permission.CAMERA) != PackageManager.PERMISSION_GRANTED) {
                    requestPermissions(new String[]{Manifest.permission.CAMERA}, MY_CAMERA_PERMISSION_CODE);
                } else {
                    Intent cameraIntent = new Intent(android.provider.MediaStore.ACTION_IMAGE_CAPTURE);
                    startActivityForResult(cameraIntent, CAMERA_REQUEST);
                }
            }
        });

        //Ajouter le produit en base de données
        bouttonAjouterProduit = findViewById(R.id.ajouterProduit);
        bouttonAjouterProduit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
                productMarque = findViewById(R.id.marqueProduit);
                productCategorie = findViewById(R.id.categorieProduit);

                productReference = findViewById(R.id.referenceProduit);
                productCouleurs = findViewById(R.id.colorisProduit);

                productStock = findViewById(R.id.stockProduit);

                productPrice = findViewById(R.id.prixProduit);
                productPricePromo = findViewById(R.id.prixPromoProduit);


                productQuantityPack = findViewById(R.id.quantitePackProduit);

                productAncienneReference = findViewById(R.id.ancienneReferenceProduit);
                //Récupérer la donnée de la liste ou du input

                textProductCategorie = productCategorie.getSelectedItem().toString();
                textProductMarque = productMarque.getSelectedItem().toString();
                textProductReference = productReference.getText().toString();
                textProductColor = productCouleurs.getSelectedItem().toString();
                textProductPrice = productPrice.getText().toString();
                textProductStock = productStock.getText().toString();
                textProductAncienneReference = productAncienneReference.getText().toString();
                textProductPricePromo = productPricePromo.getText().toString();
                textProductQuantityPack = productQuantityPack.getText().toString();
                textProductNumRayon = productNumRayon.getText().toString();
                textProductTM = productTM.getText().toString();

                //Lors du clic sur le bouton ajouter, ajout en base de données
                //Contrôle des champs requis

                if (textProductReference.trim().equals("")) {
                    Toast.makeText(getApplicationContext(), "La référence est obligatoire!", Toast.LENGTH_LONG).show();
                } else {
                    //Ajout du produit sur le back-office
                    new AddProductDataBaseAsyncTask().execute(textProductMarque, textProductCategorie, textProductReference, textProductColor, textProductAncienneReference, textProductTM, textProductPrice, textProductPricePromo, textProductQuantityPack, textProductStock, textProductNumRayon, imageProduitBase64);
                    //Vider tous les champs après envoi
                    productCategorie.setSelection(0);
                    productMarque.setSelection(0);
                    productReference.setText("");
                    productCouleurs.setSelection(0);
                    productPrice.setText("");
                    productStock.setText("");
                    productAncienneReference.setText("");
                    productPricePromo.setText("");
                    productQuantityPack.setText("");
                    productTM.setText("");
                    productNumRayon.setText("");
                    imageView = findViewById(R.id.imageView);
                    imageView.setBackgroundResource(R.drawable.image_not_found);
                    //finish();
                }

            }
        });
        Button bouttonAnulerProduit;
        bouttonAnulerProduit = findViewById(R.id.annulerProduit);
        bouttonAnulerProduit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
                finish();
            }
        });
    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

    }

    @Override
    protected void onResume() {
        super.onResume();

        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);

        if (requestCode == MY_CAMERA_PERMISSION_CODE) {
            if (grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                Toast.makeText(this, "Permission caméra autorisée", Toast.LENGTH_LONG).show();
                Intent cameraIntent = new Intent(android.provider.MediaStore.ACTION_IMAGE_CAPTURE);
                startActivityForResult(cameraIntent, CAMERA_REQUEST);
            } else {
                Toast.makeText(this, "Permission caméra refusée", Toast.LENGTH_LONG).show();
            }
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == CAMERA_REQUEST && resultCode == Activity.RESULT_OK) {
            Bitmap photo = (Bitmap) data.getExtras().get("data");
            Drawable photoBitmap = new BitmapDrawable(getResources(), photo);
            imageView.setBackground(photoBitmap);

            imageProduitBase64 = getBase64ImageStringFromBitmap(photo);
        }
    }


    //Masquer le clavier quand on appuie en dehors du champ
    @Override
    public boolean dispatchTouchEvent(MotionEvent ev) {
        if (getCurrentFocus() != null) {
            InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(getCurrentFocus().getWindowToken(), 0);
        }
        return super.dispatchTouchEvent(ev);
    }

    protected void updateSpinnerMarqueProduits(String[] marques) {
        Spinner spinnerMarqueProduits = findViewById(R.id.marqueProduit);
        ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(this, android.R.layout.simple_spinner_item, marques);
        spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
        spinnerMarqueProduits.setAdapter(spinnerArrayAdapter);
    }

    protected void updateSpinnerCategorieProduits(String[] categories) {
        Spinner spinnerCategorieProduits = findViewById(R.id.categorieProduit);
        ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(this, android.R.layout.simple_spinner_item, categories);
        spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
        spinnerCategorieProduits.setAdapter(spinnerArrayAdapter);
    }

    protected void updateSpinnerCouleursProduits(String[] produits) {
        Spinner spinnerCouleursProduits = findViewById(R.id.colorisProduit);
        ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(this, android.R.layout.simple_spinner_item, produits);
        spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
        spinnerCouleursProduits.setAdapter(spinnerArrayAdapter);
    }

    public class AddProductDataBaseAsyncTask extends AsyncTask<String, String, Integer> {

        private final String BASE_URL = MainActivity.backOfficeURL;
        ProgressDialog waiting;
        private int success;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected Integer doInBackground(String... params) {

            HttpJsonParser httpJsonParser1 = new HttpJsonParser();
            Map<String, String> httpParams1 = new HashMap<>();

            //String textProductMarque,textProductCategorie,textProductReference,textProductColor,textProductAncienneReference,textProductTM,textProductPrice,textProductPricePromo,textProductQuantityPack,textProductStock,textProductNumRayon,imageProduitBase64
            httpParams1.put("product_marque", params[0]);
            httpParams1.put("product_designation", params[1]);
            httpParams1.put("product_reference", params[2]);
            httpParams1.put("product_color", params[3]);
            httpParams1.put("product_code_128", params[4]);
            httpParams1.put("product_code_tm", params[5]);
            httpParams1.put("product_price", params[6]);
            httpParams1.put("product_price_promo", params[7]);
            httpParams1.put("product_quantity_packs", params[8]);
            httpParams1.put("product_stock", params[9]);
            httpParams1.put("product_rayon", params[10]);
            httpParams1.put("product_image_base64", params[11]);
            httpParams1.put("product_commandable", "X");

            JSONObject jsonObject1 = httpJsonParser1.makeHttpRequest(
                    BASE_URL + "ajouterProduit.php", "POST", httpParams1);
            try {
                success = jsonObject1.getInt("success");
                if (success == 1) {
                    return 1;
                } else {
                    return 0;
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }

            return 0;
        }

        @Override
        protected void onPostExecute(Integer s) {
            super.onPostExecute(s);
            retourAjoutProduit = s;

            //Supprimer l'ancienne image après envoi
            imageProduitBase64 = null;
            //Suppression de tous les champs du formulaire
            runOnUiThread(new Runnable()
            {
                public void run()
                {
                    if (retourAjoutProduit == 1) {
                        Toast.makeText(AjouterProduitActivity.this, "Le produit à été ajouté !", Toast.LENGTH_SHORT).show();
                    } else {
                        Toast.makeText(AjouterProduitActivity.this, "Une erreur est survenue !", Toast.LENGTH_SHORT).show();
                    }
                }
            });

        }

    }

    private class GetAllMarqueProduitsAsyncTask extends AsyncTask<String, String, String> {
        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeMarqueProduits.php", "GET", null);
            try {
                int success = jsonObject.getInt("success");
                JSONArray marqueMarqueProduits;
                if (success == 1) {
                    marqueMarqueProduits = jsonObject.getJSONArray("data");
                    String[] arrayMarqueProduit = new String[marqueMarqueProduits.length() + 1];
                    arrayMarqueProduit[0] = "--- Marque ---";
                    for (int i = 0; i < marqueMarqueProduits.length(); i++) {
                        JSONObject MarqueProduit = marqueMarqueProduits.getJSONObject(i);
                        try {
                            arrayMarqueProduit[i + 1] = MarqueProduit.getString("nom");
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                    AjouterProduitActivity.listeAllMarqueProduits = arrayMarqueProduit;
                }
            } catch (JSONException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            //Mise a jour de la liste déroulante des marques
            updateSpinnerMarqueProduits(AjouterProduitActivity.listeAllMarqueProduits);
        }
    }

    private class GetAllColorisProduitsAsyncTask extends AsyncTask<String, String, String> {
        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeCouleursProduits.php", "GET", null);
            try {
                int success = jsonObject.getInt("success");
                JSONArray couleursProduits;
                if (success == 1) {
                    couleursProduits = jsonObject.getJSONArray("data");
                    String[] arrayCategorieProduit = new String[couleursProduits.length() + 1];
                    arrayCategorieProduit[0] = "--- Couleur ---";
                    for (int i = 0; i < couleursProduits.length(); i++) {
                        JSONObject CouleursProduit = couleursProduits.getJSONObject(i);
                        try {
                            arrayCategorieProduit[i + 1] = CouleursProduit.getString("nom");
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                    AjouterProduitActivity.listeAllCouleursProduits = arrayCategorieProduit;
                }
            } catch (JSONException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            //Mise a jour de la liste déroulante des marques
            updateSpinnerCouleursProduits(AjouterProduitActivity.listeAllCouleursProduits);
        }
    }

    private class GetAllCategorieProduitsAsyncTask extends AsyncTask<String, String, String> {
        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeCategorieProduits.php", "GET", null);
            try {
                int success = jsonObject.getInt("success");
                JSONArray categorieProduits;
                if (success == 1) {
                    categorieProduits = jsonObject.getJSONArray("data");
                    String[] arrayCategorieProduit = new String[categorieProduits.length() + 1];
                    arrayCategorieProduit[0] = "--- Désignation ---";
                    for (int i = 0; i < categorieProduits.length(); i++) {
                        JSONObject CategorieProduit = categorieProduits.getJSONObject(i);
                        try {
                            arrayCategorieProduit[i + 1] = CategorieProduit.getString("nom");
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                    AjouterProduitActivity.listeAllCategorieProduits = arrayCategorieProduit;
                }
            } catch (JSONException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            //Mise a jour de la liste déroulante des marques
            updateSpinnerCategorieProduits(AjouterProduitActivity.listeAllCategorieProduits);
        }
    }

}
