package fr.itsee.zelyx;

import android.os.Parcel;
import android.os.Parcelable;

import java.util.ArrayList;
import java.util.List;

public class Commande implements Parcelable {

    public static final Creator<Commande> CREATOR = new Creator<Commande>() {
        @Override
        public Commande createFromParcel(Parcel in) {
            return new Commande(in);
        }

        @Override
        public Commande[] newArray(int size) {
            return new Commande[size];
        }
    };
    private String num;
    private String nomClient;
    private String date;
    private int qtetotal;
    private double prixTotal;
    private String modeLivraison = "aucun";
    private List<Produit> listeProduit;
    private double remiseGlobale = 0.0;
    private String id_operateur = "0";

    public Commande() {
        this.listeProduit = new ArrayList<Produit>();
    }

    protected Commande(Parcel in) {
        num = in.readString();
        nomClient = in.readString();
        date = in.readString();
        qtetotal = in.readInt();
        prixTotal = in.readDouble();
        modeLivraison = in.readString();
        listeProduit = in.readArrayList(Produit.class.getClassLoader());
        remiseGlobale = in.readDouble();
        id_operateur = in.readString();
    }

    public void addProduit(Produit p) {
        listeProduit.add(0, p);
        incPrixTotal(p.getPrixTotale());
        qtetotal = listeProduit.size();
    }

    public void delProduit(Produit p) {
        listeProduit.remove(p);
        decPrixTotal(p.getPrixTotale());
        qtetotal = listeProduit.size();
    }

    public void setId_operateur(String id_operateur) { this.id_operateur = id_operateur; }

    public String getId_operateur() { return id_operateur; };

    public void setRemiseGlobalePourcentage(double n) { this.remiseGlobale = n; }

    public Double getRemiseGlobalePourcentage() { return remiseGlobale; }

    public void incPrixTotal(double n) {
        this.prixTotal += n;
    }

    public void decPrixTotal(double n) {
        this.prixTotal -= n;
    }

    public List<Produit> getListeProduit() {
        return listeProduit;
    }

    public void setListeProduit(List<Produit> listeProduit) {
        this.listeProduit = listeProduit;
    }

    public String getModeLivraison() {
        return modeLivraison;
    }

    public void setModeLivraison(String modeLivraison) {
        this.modeLivraison = modeLivraison;
    }

    public String getDate() {
        return date;
    }

    public void setDate(String date) {
        this.date = date;
    }

    public String getNum() {
        return num;
    }

    public void setNum(String num) {
        this.num = num;
    }

    public int getQtetotal() {
        //Retourne le nombre complet d'article (Nombre de paquets * nombre de produits du paquet anciennement)
        int cpt = 0;
        for (Produit p : listeProduit) {
            cpt += p.getQte();
        }
        qtetotal = cpt;
        return qtetotal;
    }

    public void setQtetotal(int qtetotal) {
        this.qtetotal = qtetotal;
    }

    public String getNomClient() {
        return nomClient;
    }

    public void setNomClient(String nomClient) {
        this.nomClient = nomClient;
    }

    public double getPrixTotal() {
        double cpt = 0;
        for (Produit p : listeProduit) {
            cpt += p.getPrixTotale();
        }
        prixTotal = cpt;
        return prixTotal;
    }

    public double getRemiseTotal() {
        return ((getPrixTotal()*getRemiseGlobalePourcentage())/100);
    }

    public double getPrixTotalAvecRemise() {
        return ((getPrixTotal()-getRemiseTotal()));
    }

    public void setPrixTotal(double prixTotal) {
        this.prixTotal = prixTotal;
    }

    @Override
    public String toString() {
        return "" + num + ": " + listeProduit;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeString(num);
        parcel.writeString(nomClient);
        parcel.writeString(date);
        parcel.writeInt(qtetotal);
        parcel.writeDouble(prixTotal);
        parcel.writeString(modeLivraison);
        parcel.writeList(listeProduit);
        parcel.writeDouble(remiseGlobale);
        parcel.writeString(id_operateur);
    }
}
