package fr.itsee.zelyx;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.graphics.Bitmap;
import android.graphics.Typeface;
import android.graphics.drawable.Drawable;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.provider.Settings;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.DividerItemDecoration;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.Html;
import android.text.method.ScrollingMovementMethod;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.SearchView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.google.zxing.integration.android.IntentIntegrator;
import com.google.zxing.integration.android.IntentResult;
import com.squareup.picasso.Picasso;
import com.symbol.emdk.EMDKManager;
import com.symbol.emdk.EMDKManager.EMDKListener;
import com.symbol.emdk.EMDKManager.FEATURE_TYPE;
import com.symbol.emdk.EMDKResults;
import com.symbol.emdk.barcode.BarcodeManager;
import com.symbol.emdk.barcode.BarcodeManager.ConnectionState;
import com.symbol.emdk.barcode.BarcodeManager.ScannerConnectionListener;
import com.symbol.emdk.barcode.ScanDataCollection;
import com.symbol.emdk.barcode.ScanDataCollection.ScanData;
import com.symbol.emdk.barcode.Scanner;
import com.symbol.emdk.barcode.Scanner.DataListener;
import com.symbol.emdk.barcode.Scanner.StatusListener;
import com.symbol.emdk.barcode.Scanner.TriggerType;
import com.symbol.emdk.barcode.ScannerConfig;
import com.symbol.emdk.barcode.ScannerException;
import com.symbol.emdk.barcode.ScannerInfo;
import com.symbol.emdk.barcode.ScannerResults;
import com.symbol.emdk.barcode.StatusData;
import com.symbol.emdk.barcode.StatusData.ScannerStates;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.text.DateFormat;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;

/* ZEBRA */
/*public class CommandesActivity extends AppCompatActivity implements CompoundButton.OnCheckedChangeListener {*/
public class CommandesActivity extends AppCompatActivity implements EMDKListener, DataListener, StatusListener, ScannerConnectionListener, CompoundButton.OnCheckedChangeListener {
    public static ProduitAdapter mAdapter;
    public static TextView prixTotal, qteTotal, remiseGlobaleTotal, textRemiseGlobale;
    public static LinearLayout remiseGlobaleLigne;
    public static Map<String, Bitmap> dicImages;
    public static List<Produit> listeAllProduits;
    public static Commande currentCommande;
    public static Commande currentCommandeFiltre;
    public static Commande commandeAImprimer = new Commande();
    static Boolean filtreRechercheEnCours = false;
    private static TextView num;
    //private static String typeTicket;
    private final Object lock = new Object();
    public List<Produit> listeRupture;
    List<Commande> listeCommande = new ArrayList<>(3);
    Button BarCodeCamera;
    /*public class CommandesActivity extends AppCompatActivity {*/
    private RecyclerView recyclerView;
    private TextView date, actifTab, previousTab, c1, c2, c3, c4, mode;
    private SearchView searchBar, searchBarProduitCommande;
    private EditText nom;
    private int selectedTab = 1;
    private Commande newCommande;
    private Commande commandeVide = new Commande();
    /* ZEBRA */
    //Partie Scanner
    private EMDKManager emdkManager = null;
    private BarcodeManager barcodeManager = null;
    private Scanner scanner = null;
    private TextView textViewData = null;
    private TextView textViewStatus = null;
    private CheckBox checkBoxEAN8 = null;
    private CheckBox checkBoxEAN13 = null;
    private CheckBox checkBoxCode39 = null;
    private CheckBox checkBoxCode128 = null;
    private Spinner spinnerScannerDevices = null;
    /* ZEBRA */
    private List<ScannerInfo> deviceList = null;
    private RecyclerView listeCommandes = null;
    private int scannerIndex = 0; // Keep the selected scanner
    private int defaultIndex = 0; // Keep the default scanner
    private int dataLength = 0;
    private String statusString = "";
    //SCANNER EN PERMANENCE (bSoftTriggerSelected = TRUE)
    private boolean bSoftTriggerSelected = true;
    private boolean bDecoderSettingsChanged = false;
    private boolean bExtScannerDisconnected = false;
    private ImageView image_produit_full;
    private TextView initialesVendeur, codeBoutique;
    private Button activerToujoursScanner;
    private Boolean scanEnPermanence = false;
    private List<Commande> resultatRecherche;
    private ImageView ajouterRemiseCommande;

    public static Produit getProduitInCommande(String code128) {
        for (Produit pr : currentCommande.getListeProduit()) {
            if (pr.getCode128().equals(code128)) {
                return pr;
            }
        }
        return null;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_commandes_v3);

        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

        try {
            new GetAllProduitsAsyncTask().execute();
        } catch (Exception e) {
            e.printStackTrace();
        }

        date = findViewById(R.id.date);
        num = findViewById(R.id.num);
        nom = findViewById(R.id.nom);
        remiseGlobaleLigne = findViewById(R.id.remiseGlobaleLigne);
        textRemiseGlobale = findViewById(R.id.textRemiseGlobale);
        remiseGlobaleTotal = findViewById(R.id.remiseGobaleTotal);
        prixTotal = findViewById(R.id.prixTotal);
        searchBar = findViewById(R.id.bar_de_recherche);
        searchBarProduitCommande = findViewById(R.id.bar_de_recherche_commande);
        qteTotal = findViewById(R.id.qteTotal);
        c1 = findViewById(R.id.c1);
        c2 = findViewById(R.id.c2);
        c3 = findViewById(R.id.c3);
        c4 = findViewById(R.id.c4);
        ajouterRemiseCommande = findViewById(R.id.remiseGlobale);

        mode = findViewById(R.id.mode);
        actifTab = c1;
        previousTab = null;
        actifTab.setTextColor(getResources().getColor(R.color.colorBlanc));
        actifTab.setBackgroundResource(R.drawable.button_style_selected);
        actifTab.setTypeface(null, Typeface.BOLD);

        dicImages = new HashMap<>();
        mAdapter = new ProduitAdapter(new Commande(), getApplicationContext());

        listeCommande.add(null);
        listeCommande.add(null);
        listeCommande.add(null);

        getListeCommandes();

        recyclerView = findViewById(R.id.recycler_view);
        textViewData = findViewById(R.id.textViewData);
        textViewStatus = findViewById(R.id.textViewStatus);
        checkBoxEAN8 = findViewById(R.id.checkBoxEAN8);
        checkBoxEAN13 = findViewById(R.id.checkBoxEAN13);
        checkBoxCode39 = findViewById(R.id.checkBoxCode39);
        checkBoxCode128 = findViewById(R.id.checkBoxCode128);
        spinnerScannerDevices = findViewById(R.id.spinnerScannerDevices);

        currentCommande = listeCommande.get(selectedTab - 1);
        currentCommandeFiltre = listeCommande.get(selectedTab - 1);

        RecyclerView.LayoutManager mLayoutManager = new LinearLayoutManager(getApplicationContext());
        recyclerView.setLayoutManager(mLayoutManager);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
        recyclerView.addItemDecoration(new DividerItemDecoration(this, LinearLayoutManager.VERTICAL));
        recyclerView.setAdapter(mAdapter);

        initialesVendeur = findViewById(R.id.initialesVendeur);
        codeBoutique = findViewById(R.id.codeBoutique);
        initialesVendeur.setText(IdentificationActivity.initiales_vendeur);
        codeBoutique.setText(IdentificationActivity.code_boutique);

        image_produit_full = findViewById(R.id.image_produit_full);

        /*RE-IMPRIMER TICKET*/
        c4.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Toast.makeText(getApplicationContext(), "Réimmp. !", Toast.LENGTH_SHORT).show();
                if (CommandesActivity.listeAllProduits == null) {
                    new GetAllProduitsAsyncTask().execute();
                } else {
                    DialogCommandesActivityListCommandesJour.show(CommandesActivity.this, 0);
                }
            }
        });

        ajouterRemiseCommande.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (currentCommande != null) {
                    DialogRemiseGlobaleActivityEditRemise.show(CommandesActivity.this, 0);
                    // Fermer le clavier
                    InputMethodManager imm = (InputMethodManager) CommandesActivity.this.getSystemService(Context.INPUT_METHOD_SERVICE);
                    imm.toggleSoftInput(InputMethodManager.HIDE_IMPLICIT_ONLY, 0);
                } else {
                    Toast.makeText(CommandesActivity.this, "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
                }
            }
        });

        activerToujoursScanner = findViewById(R.id.activerToujoursScanner);
        activerToujoursScanner.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (scanEnPermanence) {
                    scanEnPermanence = false;
                    activerToujoursScanner.setBackgroundResource(R.drawable.barcode_scanner_manuel);
                } else {
                    scanEnPermanence = true;
                    activerToujoursScanner.setBackgroundResource(R.drawable.barcode_scanner);
                }
                try {
                    if (scanner.isReadPending()) {
                        scanner.cancelRead();
                    }

                    if (!scanEnPermanence)
                        scanner.triggerType = TriggerType.SOFT_ONCE;
                    else
                        scanner.triggerType = TriggerType.SOFT_ALWAYS;

                    scanner.read();
                } catch (ScannerException e) {

                }
            }
        });

        searchBarProduitCommande.setOnQueryTextListener(new SearchView.OnQueryTextListener() {
            @Override
            public boolean onQueryTextSubmit(String s) {
                searchBarProduitCommande.clearFocus();
                faireRecherche(searchBarProduitCommande.getQuery().toString());
                if (!searchBarProduitCommande.getQuery().toString().isEmpty()) {
                    filtreRechercheEnCours = true;
                    mAdapter.setCmd(currentCommandeFiltre);
                } else {
                    filtreRechercheEnCours = false;
                    mAdapter.setCmd(currentCommande);
                }
                if (s.isEmpty()) {
                    filtreRechercheEnCours = false;
                    mAdapter.setCmd(currentCommande);
                }
                mAdapter.notifyDataSetChanged();
                return false;
            }

            @Override
            public boolean onQueryTextChange(String s) {
                if (searchBarProduitCommande.getQuery().toString() != "") {
                    filtreRechercheEnCours = true;
                    faireRecherche(searchBarProduitCommande.getQuery().toString());
                    mAdapter.setCmd(currentCommandeFiltre);
                } else {
                    filtreRechercheEnCours = false;
                    mAdapter.setCmd(currentCommande); //Remise à 0 si pas de recherche
                    afficheCommande();
                }
                if (s.isEmpty()) {
                    filtreRechercheEnCours = false;
                    mAdapter.setCmd(currentCommande);
                }

                mAdapter.notifyDataSetChanged();
                return false;
            }
        });
        searchBarProduitCommande.clearFocus();
        filtreRechercheEnCours = false;


        mAdapter.setOnItemClickListener(new ProduitAdapter.OnItemClickListener() {
            protected boolean isOnline() {
                ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
                NetworkInfo netInfo = cm.getActiveNetworkInfo();
                return netInfo != null && netInfo.isConnectedOrConnecting();
            }

            @Override
            public void onRefClick(int position) {
                if (filtreRechercheEnCours == false) {
                    Intent intent = new Intent(CommandesActivity.this, FicheProduitActivity.class);
                    intent.putExtra("produit", getProduit(position));
                    startActivityForResult(intent, 3);
                } else {
                    Toast.makeText(getApplicationContext(), "Recherche en cours...", Toast.LENGTH_SHORT).show();
                }
            }

            @Override
            public void onPhotoClick(int position, Drawable imageDrawable, String lien_image) {
                if (filtreRechercheEnCours == false) {
                    Picasso.with(getApplicationContext()).load(MainActivity.backOfficeURLIMG + lien_image.replace(".jpg", "_full.jpg")).into(image_produit_full);
                    image_produit_full.setVisibility(View.VISIBLE);
                    image_produit_full.setEnabled(true);
                    image_produit_full.setAdjustViewBounds(true);
                } else {
                    Toast.makeText(getApplicationContext(), "Recherche en cours...", Toast.LENGTH_SHORT).show();
                }
            }

            @Override
            public void onSupprClick(final int position) {
                if (filtreRechercheEnCours == false) {
                    new AlertDialog.Builder(CommandesActivity.this)
                            .setIcon(android.R.drawable.ic_dialog_alert)
                            .setTitle("Confirmation")
                            .setMessage("Etes-vous sûr de vouloir supprimer ce produit?")
                            .setPositiveButton("Oui", new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                    currentCommande.delProduit(getProduit(position));
                                    mAdapter.notifyDataSetChanged();
                                    afficheCommande();
                                }

                            })
                            .setNegativeButton("Non", null)
                            .show();
                } else {
                    Toast.makeText(getApplicationContext(), "Recherche en cours...", Toast.LENGTH_SHORT).show();
                }
            }

            @Override
            public void onPlusClick(int position) {
                if (filtreRechercheEnCours == false) {
                    if (!isOnline()) {
                        Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
                    } else {
                        Produit p = getProduit(position);
                        //actualisation du stock de ce produit
                        new RefreshProduitAsyncTask().execute(p);

                        int reste = p.getStock() - p.getQte() - 1;

                        if (reste == 0) {
                            Toast.makeText(getApplicationContext(), "stock null", Toast.LENGTH_SHORT).show();
                            p.incQte();
                        } else {
                            p.incQte();
                        }

                        //ITSEE Mise à jour en back-office
                        //new UpdateCommandeAsyncTask().execute(); //Erreur 503
                        afficheCommande();
                    }
                } else {
                    Toast.makeText(getApplicationContext(), "Recherche en cours...", Toast.LENGTH_SHORT).show();
                }
            }

            @Override
            public void onMoinsClick(int position) {
                if (filtreRechercheEnCours == false) {
                    if (!isOnline()) {
                        Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
                    } else {
                        Produit p = getProduit(position);

                        new RefreshProduitAsyncTask().execute(p);

                        //if (p.getQte() == 1) {
                        //currentCommande.delProduit(getProduit(position)); //Permet de supprimer si quantite = 0
                        //} else {
                        currentCommande.getListeProduit().get(position).decQte();
                        //}
                        //ITSEE Mise à jour en back-office
                        //new UpdateCommandeAsyncTask().execute(); //Erreur 503 OVH
                        afficheCommande();
                    }
                } else {
                    Toast.makeText(getApplicationContext(), "Recherche en cours...", Toast.LENGTH_SHORT).show();
                }
            }

            @Override
            public void onQuantiteClick(int position) {
                if (filtreRechercheEnCours == false) {
                    DialogCommandesActivityEditQte.show(CommandesActivity.this, position);
                } else {
                    Toast.makeText(getApplicationContext(), "Recherche en cours...", Toast.LENGTH_SHORT).show();
                }
            }

            @Override
            public void onPrixClick(int position) {
                if (filtreRechercheEnCours == false) {
                    DialogCommandesActivityEditPrix.show(CommandesActivity.this, position);
                } else {
                    Toast.makeText(getApplicationContext(), "Recherche en cours...", Toast.LENGTH_SHORT).show();
                }
            }

        });

        //permet de refermer la photo produit
        image_produit_full.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (filtreRechercheEnCours == false) {
                    image_produit_full.setImageDrawable(null);
                    image_produit_full.setVisibility(View.INVISIBLE);
                    image_produit_full.setEnabled(false);
                    image_produit_full.setAdjustViewBounds(false);
                } else {
                    Toast.makeText(getApplicationContext(), "Recherche en cours...", Toast.LENGTH_SHORT).show();
                }
            }
        });

        searchBar.setOnQueryTextListener(new SearchView.OnQueryTextListener() {
            @Override
            public boolean onQueryTextSubmit(String s) {
                if (!isOnline()) {
                    Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
                } else {
                    searchBar.clearFocus();
                    Intent intent = new Intent(CommandesActivity.this, RechercheActivity.class);
                    intent.putExtra("recherche", s);
                    startActivityForResult(intent, 4);
                }
                return false;
            }

            @Override
            public boolean onQueryTextChange(String s) {
                return false;
            }
        });

        currentCommande = listeCommande.get(selectedTab - 1);

        if (currentCommande != null) {
            mAdapter.setCmd(currentCommande);
            recyclerView.setAdapter(mAdapter);
            afficheCommande();
        }

        /* ZEBRA */
        deviceList = new ArrayList<ScannerInfo>();

        EMDKResults results = EMDKManager.getEMDKManager(getApplicationContext(), this);
        if (results.statusCode != EMDKResults.STATUS_CODE.SUCCESS) {
            updateStatus("EMDKManager object request failed!");
            return;
        }


        checkBoxEAN8.setOnCheckedChangeListener(this);
        checkBoxEAN13.setOnCheckedChangeListener(this);
        checkBoxCode39.setOnCheckedChangeListener(this);
        checkBoxCode128.setOnCheckedChangeListener(this);

        addSpinnerScannerDevicesListener();


        textViewData.setSelected(true);
        textViewData.setMovementMethod(new ScrollingMovementMethod());


        nom.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView textView, int i, KeyEvent keyEvent) {
                if (currentCommande != null) {
                    currentCommande.setNomClient(String.valueOf(textView.getText()));
                    //new UpdateCommandeAsyncTask().execute(); //Erreur 503 ovh

                }
                return false;
            }
        });

        nom.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View view, boolean b) {
                if (currentCommande != null) {
                    currentCommande.setNomClient(String.valueOf(((EditText) view).getText()));
                    //new UpdateCommandeAsyncTask().execute(); //Erreur 503 ovh
                }
            }
        });

        /* NON ZEBRA */
        /*SCAN APPAREIL PHOTO*/
        BarCodeCamera = findViewById(R.id.newScan);
        final Activity activity = this;
        final Collection<String> PRODUCT_CODE_128 = Arrays.asList("CODE_128");
        BarCodeCamera.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //Tester si nous sommes sur une commande en cours
                /*if (currentCommande != null) {
                    nom.clearFocus();
                    searchBar.clearFocus();
                    IntentIntegrator intentIntegrator = new IntentIntegrator(activity);
                    intentIntegrator.setDesiredBarcodeFormats(IntentIntegrator.ALL_CODE_TYPES);
                    intentIntegrator.setBeepEnabled(false);
                    intentIntegrator.setCameraId(0);
                    intentIntegrator.setPrompt("SCANNER UN PRODUIT A AJOUTER");
                    intentIntegrator.setBarcodeImageEnabled(false);
                    intentIntegrator.initiateScan();
                } else {
                    Toast.makeText(CommandesActivity.this, "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
                }*/
                /*SYNCHRONISATION DE LA COMMANDE*/
                new UpdateCommandeAsyncTask().execute();
                /*SYNCHRONISATION DE LA LISTE DES PRODUITS*/
                /*SYNCHRONISATION DE LA LISTE DES PRODUITS*/
                CommandesActivity.listeAllProduits = null; //Vider les produits pour les rafraichir. Ne rafraichi pas si produis existants
                new GetAllProduitsAsyncTask().execute();
                Toast.makeText(CommandesActivity.this, "Sync. en cours...", Toast.LENGTH_SHORT).show();
            }
        });

    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

    }

    public Produit getProduit(int position) {
        return currentCommande.getListeProduit().get(position);
    }

    public void changetab(View v) {
        previousTab = actifTab;
        actifTab.setTextColor(getResources().getColor(R.color.colorBlanc));
        actifTab.setBackgroundResource(R.drawable.button_style);
        actifTab.setTypeface(null, Typeface.NORMAL);
        actifTab = ((TextView) v);
        actifTab.setTextColor(getResources().getColor(R.color.colorBlanc));
        actifTab.setBackgroundResource(R.drawable.button_style_selected);
        actifTab.setTypeface(null, Typeface.BOLD);
        selectedTab = Integer.parseInt(actifTab.getText().toString());

        if (listeCommande.get(selectedTab - 1) == null) {
            currentCommande = listeCommande.get(selectedTab - 1);
            mAdapter.setCmd(commandeVide);
            recyclerView.setAdapter(mAdapter);
            afficheCommande();
        } else {
            currentCommande = listeCommande.get(selectedTab - 1);
            mAdapter.setCmd(currentCommande);
            recyclerView.setAdapter(mAdapter);
            afficheCommande();
        }
    }

    @Override
    protected void onStop() {
        super.onStop();
        saveListeCommandes();
    }

    public void saveListeCommandes() {
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();
        sharedPreferences.edit().putString("listeCommande", gson.toJson(listeCommande)).apply();

    }

    public void getListeCommandes() {
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();

        String json = sharedPreferences.getString("listeCommande", null);

        if (json != null) {
            listeCommande = gson.fromJson(json, new TypeToken<List<Commande>>() {
            }.getType());
        }
    }

    public void afficheCommande() {
        filtreRechercheEnCours = false;
        currentCommande = listeCommande.get(selectedTab - 1);
        //DecimalFormat df = new DecimalFormat("#,###,##0.00");
        DecimalFormat df = new DecimalFormat("0.00");
        if (currentCommande != null) {
            //date.setText("Date: " + currentCommande.getDate());
            date.setText("Date: " + new SimpleDateFormat("dd-MM-yyyy", Locale.getDefault()).format(new Date()));
            num.setText("n°" + currentCommande.getNum());
            mode.setText(currentCommande.getModeLivraison());
            nom.setEnabled(true);
            if (currentCommande.getNomClient().equals("")) {
                nom.setText("");
            } else {
                nom.setText(currentCommande.getNomClient());
            }
            textRemiseGlobale.setText("Remise (" + currentCommande.getRemiseGlobalePourcentage() + "%):");
            prixTotal.setText("" + (df.format(currentCommande.getPrixTotalAvecRemise())));
            remiseGlobaleTotal.setText("-" + (df.format(currentCommande.getRemiseTotal())));
            if (currentCommande.getRemiseGlobalePourcentage() != 0.0) {
                remiseGlobaleLigne.setVisibility(View.VISIBLE);
            }

            qteTotal.setText("" + (currentCommande.getQtetotal()));

            mode.setText(currentCommande.getModeLivraison());
            mAdapter.notifyDataSetChanged();
        } else {
            date.setText("");
            num.setText("");
            mode.setText("");
            nom.setText("");
            nom.setEnabled(false);
            prixTotal.setText("");
            qteTotal.setText("");
            remiseGlobaleTotal.setText("");
            textRemiseGlobale.setText("");
            remiseGlobaleLigne.setVisibility(View.INVISIBLE);
            mAdapter.notifyDataSetChanged();
        }
    }

    /*private void lancerTicketDetail() {
        Intent intent = new Intent(getApplicationContext(), PrinterActivity.class);
        intent.putExtra("commande", currentCommande);
        intent.putExtra("typeticket", "detaillee");
        startActivity(intent);
    }

    private void lancerTicketRassemble() {
        Intent intent = new Intent(getApplicationContext(), PrinterActivity.class);
        intent.putExtra("commande", currentCommande);
        intent.putExtra("typeticket", "rassemblee");
        startActivity(intent);
    }*/


    public void imprimerCommande(View v) {
        //Détecter si la mac imprimante est configurée sinon pas possible de finaliser la commande
        if (IdentificationActivity.mac_imprimante == "") {
            Intent intent = new Intent(CommandesActivity.this, IdentificationActivity.class);
            startActivity(intent);
            finish();
        }

        if (currentCommande != null) {
            if (!currentCommande.getNomClient().equals("")) {
                if (!currentCommande.getModeLivraison().equals("aucun")) {
                    if (currentCommande.getListeProduit().size() > 0) {
                        if (!isOnline()) {
                            Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
                        } else {
                            //Contrôler le stock uniquement lors de la finalisation de la commande
                            new RefreshStockAsyncTask().execute();
                            currentCommande.setNum(num.getText().toString().replace("n°", ""));
                            //On affiche la fenetre de dialogue du choix du ticket
                            new AlertDialog.Builder(CommandesActivity.this)
                                    .setIcon(android.R.drawable.ic_dialog_alert)
                                    .setTitle("Confirmation")
                                    .setMessage("Quel type de ticket souhaitez-vous imprimer ?")
                                    .setPositiveButton("Détaillée", new DialogInterface.OnClickListener() {
                                        @Override
                                        public void onClick(DialogInterface dialog, int which) {
                                            //controle des stocks
                                            try {
                                                new VerifStockAsyncTask().execute();
                                                //Ajout des produits dans la commande
                                                new UpdateCommandeAsyncTask().execute();
                                                //Avant, lancement directement dans l'ordre du scan des produits
                                                //Lancement de l'impression detaillee
                                                //Intent intent = new Intent(getApplicationContext(), PrinterActivity.class);
                                                //intent.putExtra("commande", currentCommande);
                                                //intent.putExtra("typeticket", "detaillee");
                                                //startActivity(intent);
                                                //Mise à jour du statut
                                                //new UpdateCompleteCommandeAsyncTask().execute();

                                            } catch (Exception e) {
                                                e.printStackTrace();
                                            }

                                            //Recuperation de la commande triée
                                            try {
                                                //Récupérer les informations de la commande
                                                final String BASE_URL = MainActivity.backOfficeURL;

                                                int success;
                                                HttpJsonParser httpJsonParser = new HttpJsonParser();
                                                Map<String, String> httpParams = new HashMap<>();
                                                httpParams.put("numero_commande", currentCommande.getNum());

                                                JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                                                        BASE_URL + "getCommande.php", "GET", httpParams);
                                                try {
                                                    success = jsonObject.getInt("success");

                                                    if (success == 1) {
                                                        JSONArray commandeArray = jsonObject.getJSONArray("data");
                                                        JSONObject commande = commandeArray.getJSONObject(0);
                                                        try {
                                                            commandeAImprimer = new Commande();
                                                            commandeAImprimer.setNum(commande.getString("numero_commande"));
                                                            commandeAImprimer.setNomClient(commande.getString("nom_client"));
                                                            commandeAImprimer.setDate(commande.getString("date_commande"));
                                                            commandeAImprimer.setModeLivraison(commande.getString("mode_livraison"));
                                                            commandeAImprimer.setRemiseGlobalePourcentage(commande.getDouble("remise_globale"));
                                                        } catch (Exception e) {
                                                            Toast.makeText(CommandesActivity.this, "Erreur de la récupération de la commande", Toast.LENGTH_SHORT).show();
                                                            e.printStackTrace();
                                                        }

                                                        //CHANGEMENT, récupation de la liste des produits de la commande depuis la back-office
                                                        HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                                                        Map<String, String> httpParams2 = new HashMap<>();
                                                        httpParams2.put("num_commande", commande.getString("numero_commande"));
                                                        JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                                                                BASE_URL + "listeProduitsCommande.php", "GET", httpParams2);

                                                        List<Produit> produitList = new ArrayList<>();

                                                        try {
                                                            int success2 = jsonObject2.getInt("success");
                                                            JSONArray produits;
                                                            if (success2 == 1) {
                                                                produits = jsonObject2.getJSONArray("data");


                                                                //Iterate through the response and populate produits list
                                                                for (int i = 0; i < produits.length(); i++) {
                                                                    Produit p = new Produit();
                                                                    JSONObject produit = produits.getJSONObject(i);

                                                                    try {
                                                                        p.setRef(produit.getString("reference"));
                                                                        p.setColoris(produit.getString("coloris"));
                                                                        p.setCommandable(produit.getString("commandable"));
                                                                        p.setCode128(produit.getString("code_128"));
                                                                        p.setQuantite_pack(produit.getInt("quantite_packs"));
                                                                        p.setPrix(produit.getDouble("prix"));
                                                                        p.setStock(produit.getInt("stock"));
                                                                        //Log.d("")
                                                                        p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                                                                        p.setInformations(produit.getString("informations"));
                                                                        p.setLien_image(produit.getString("lien_image"));
                                                                        p.setActif(produit.getInt("actif"));
                                                                        p.setQte(produit.getInt("quantite"));
                                                                        p.setPrixCatalogue(produit.getDouble("prix_catalogue"));
                                                                        p.setNbrScanner(0);
                                                                        produitList.add(p);
                                                                    } catch (Exception e) {
                                                                        e.printStackTrace();
                                                                    }
                                                                }

                                                                commandeAImprimer.setListeProduit(produitList);
                                                            }
                                                        } catch (JSONException e) {
                                                            e.printStackTrace();
                                                        }

                                                        //Lancement de l'impression detaillee
                                                        Intent intent = new Intent(getApplicationContext(), PrinterActivity.class);
                                                        intent.putExtra("commande", commandeAImprimer);
                                                        intent.putExtra("typeticket", "detaillee");
                                                        startActivity(intent);
                                                        //Mise à jour du statut
                                                        new UpdateCompleteCommandeAsyncTask().execute();

                                                    }
                                                } catch (JSONException e) {
                                                    e.printStackTrace();
                                                }

                                            } catch (Exception e) {
                                                e.printStackTrace();
                                            }

                                        }

                                    })
                                    .setNegativeButton("Rassemblée", new DialogInterface.OnClickListener() {
                                        @Override
                                        public void onClick(DialogInterface dialog, int which) {
                                            try {
                                                //CommandesActivity.typeTicket = "rassemblee";
                                                new VerifStockAsyncTask().execute();
                                                //Ajout des produits dans la commande
                                                new UpdateCommandeAsyncTask().execute();
                                                //Lancement de l'impression rassemblee
                                                Intent intent = new Intent(getApplicationContext(), PrinterActivity.class);
                                                intent.putExtra("commande", currentCommande);
                                                intent.putExtra("typeticket", "rassemblee");
                                                startActivity(intent);
                                                //Mise à jour du statut
                                                new UpdateCompleteCommandeAsyncTask().execute();

                                            } catch (Exception e) {
                                                e.printStackTrace();
                                            }
                                        }

                                    })
                                    .show();
                        }
                    }
                } else {
                    Toast.makeText(CommandesActivity.this, "Aucun mode de livraison choisi", Toast.LENGTH_SHORT).show();
                }
            } else {
                Toast.makeText(CommandesActivity.this, "Aucun nom de client saisi", Toast.LENGTH_SHORT).show();
            }
        } else {
            Toast.makeText(CommandesActivity.this, "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
        }
    }

    protected boolean isOnline() {
        ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo netInfo = cm.getActiveNetworkInfo();
        return netInfo != null && netInfo.isConnectedOrConnecting();
    }

    public void nouvelleCommande(View v) {

        if (isOnline()) {
            if (currentCommande != null) {
                DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        switch (which) {
                            case DialogInterface.BUTTON_POSITIVE:
                                //Annulation
                                dialog.dismiss();
                                break;

                            case DialogInterface.BUTTON_NEGATIVE:
                                //Terminer
                                new UpdateAnnulerCommandeAsyncTask().execute();

                                //DateFormat dateFormat = new SimpleDateFormat("dd-MM-yyyy");
                                //Date date = new Date();
                                //newCommande = new Commande();
                                //newCommande.setNomClient("");
                                //newCommande.setDate(dateFormat.format(date));
                                //newCommande.setQtetotal(0);
                                //newCommande.setPrixTotal(0.0);
                                //newCommande.setRemiseGlobalePourcentage(0.0);
                                //textRemiseGlobale.setText("");
                                //remiseGlobaleTotal.setText("0");
                                //remiseGlobaleLigne.setVisibility(View.INVISIBLE);
                                //newCommande.setModeLivraison("aucun");
                                //new AddCommandeAsyncTask().execute();
                                //Vide la commande en cours
                                currentCommande = null;
                                date.setText("");
                                num.setText("");
                                mode.setText("");
                                nom.setText("");
                                nom.setEnabled(false);
                                prixTotal.setText("");
                                qteTotal.setText("");
                                remiseGlobaleTotal.setText("");
                                textRemiseGlobale.setText("");
                                remiseGlobaleLigne.setVisibility(View.INVISIBLE);

                                //Permet de vraiment vider la commande de l'onglet
                                listeCommande.set(selectedTab - 1, newCommande);
                                afficheCommande();

                                dialog.dismiss();
                                break;
                        }
                    }
                };
                AlertDialog.Builder builder = new AlertDialog.Builder(this);
                builder.setTitle("Voulez-vous réellement annuler cette commande ?");
                builder.setMessage("Cette commande sera considérée comme annulée.");
                builder.setPositiveButton("Annuler", dialogClickListener);
                builder.setNegativeButton("Confirmer", dialogClickListener);
                builder.show();
            } else {
                DateFormat dateFormat = new SimpleDateFormat("dd-MM-yyyy");
                Date date = new Date();

                newCommande = new Commande();
                newCommande.setNomClient("");
                newCommande.setDate(dateFormat.format(date));
                newCommande.setQtetotal(0);
                newCommande.setPrixTotal(0.0);
                newCommande.setRemiseGlobalePourcentage(0);
                newCommande.setModeLivraison("aucun");
                textRemiseGlobale.setText("");
                remiseGlobaleTotal.setText("0");
                remiseGlobaleLigne.setVisibility(View.INVISIBLE);
                newCommande.setId_operateur(IdentificationActivity.id_operateur);
                new AddCommandeAsyncTask().execute();
            }
        } else {
            Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        nom.clearFocus();
        searchBar.clearFocus();

        IntentResult Result = IntentIntegrator.parseActivityResult(requestCode, resultCode, data);
        if (Result != null) {
            if (Result.getContents() == null) {
                Toast.makeText(this, "Saisie annulée", Toast.LENGTH_SHORT).show();
            } else {
                updateData(Result.getContents());
            }
        } else {
            super.onActivityResult(requestCode, resultCode, data);
        }

        if (requestCode == 1) {
            if (resultCode == Activity.RESULT_OK) {
                Commande newC = data.getParcelableExtra("newC");
                listeCommande.set(selectedTab - 1, newC);
                currentCommande = listeCommande.get(selectedTab - 1);
                mAdapter.setCmd(currentCommande);
                recyclerView.setAdapter(mAdapter);
                afficheCommande();
            } else if (resultCode == Activity.RESULT_CANCELED) {
                if (listeCommande.get(0) == null && listeCommande.get(1) == null && listeCommande.get(2) == null && previousTab == null) {
                    finish();
                } else {
                    previousTab.callOnClick();
                }
            }
        } else if (requestCode == 2) {
            if (resultCode == Activity.RESULT_OK) {
                String choix = data.getStringExtra("choix");
                currentCommande.setModeLivraison(choix);
                mode.setText(choix);

            } else if (resultCode == Activity.RESULT_CANCELED) {

            }
        } else if (requestCode == 3) {
            if (resultCode == Activity.RESULT_OK) {
                Produit p = data.getParcelableExtra("produit");
                ajouterProduitCommande(p.getCode128(), p.getQte());
            } else if (resultCode == Activity.RESULT_CANCELED) {

            }
        } else if (requestCode == 4) {
            if (resultCode == Activity.RESULT_OK) {
                if (currentCommande != null) {
                    Produit p = data.getParcelableExtra("produit");
                    //Depuis fiche produit
                    ajouterProduitCommande(p.getCode128(), p.getQuantite_pack());
                } else {
                    Toast.makeText(CommandesActivity.this, "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
                }

            } else if (resultCode == Activity.RESULT_CANCELED) {

            }
        }

    }

    /* ZEBRA */
    @Override
    public void onOpened(EMDKManager emdkManager) {
        updateStatus("EMDK open success!");
        this.emdkManager = emdkManager;
        // Acquire the barcode manager resources
        initBarcodeManager();
        // Enumerate scanner devices
        enumerateScannerDevices();
        // Set default scanner
        spinnerScannerDevices.setSelection(defaultIndex);
    }

    /* ZEBRA */
    @Override
    protected void onResume() {
        super.onResume();

        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

        //Détecter si la mac imprimante est configurée sinon pas possible de finaliser la commande
        if (IdentificationActivity.mac_imprimante == "") {
            Intent intent = new Intent(CommandesActivity.this, IdentificationActivity.class);
            startActivity(intent);
            finish();
        }

        if (listeAllProduits == null) {
            try {
                new GetAllProduitsAsyncTask().execute();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        // The application is in foreground
        if (emdkManager != null) {
            // Acquire the barcode manager resources
            initBarcodeManager();
            // Enumerate scanner devices
            enumerateScannerDevices();
            // Set selected scanner
            spinnerScannerDevices.setSelection(scannerIndex);
            // Initialize scanner
            initScanner();
        }
        currentCommande = listeCommande.get(selectedTab - 1);
        currentCommandeFiltre = listeCommande.get(selectedTab - 1);
    }

    @Override
    protected void onPause() {
        super.onPause();
        // The application is in background
        // Release the barcode manager resources
        deInitScanner();
        deInitBarcodeManager();
    }

    /* ZEBRA */
    @Override
    public void onClosed() {
        // Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
        updateStatus("EMDK closed unexpectedly! Please close and restart the application.");
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        saveListeCommandes();
        // Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
    }

    @Override
    public void onData(ScanDataCollection scanDataCollection) {
        if ((scanDataCollection != null) && (scanDataCollection.getResult() == ScannerResults.SUCCESS)) {
            ArrayList<ScanData> scanData = scanDataCollection.getScanData();
            for (ScanData data : scanData) {
                updateData(data.getData());
            }
        }
    }

    @Override
    public void onStatus(StatusData statusData) {
        ScannerStates state = statusData.getState();
        switch (state) {
            case IDLE:
                statusString = statusData.getFriendlyName() + " is enabled and idle...";
                updateStatus(statusString);
                // set trigger type
                if (bSoftTriggerSelected) {
                    scanner.triggerType = TriggerType.SOFT_ONCE;
                    bSoftTriggerSelected = false; //Permet de passer au mode manuel
                } else {
                    if (scanEnPermanence) {
                        scanner.triggerType = TriggerType.SOFT_ALWAYS;
                    } else {
                        scanner.triggerType = TriggerType.HARD;
                    }
                }
                // set decoders
                if (bDecoderSettingsChanged) {
                    setDecoders();
                    bDecoderSettingsChanged = false;
                }
                // submit read
                if (!scanner.isReadPending() && !bExtScannerDisconnected) {
                    try {
                        if (scanEnPermanence) {
                            try {
                                Thread.sleep(1000); //Un temps d'attente de 1 seconde entre chaque scan
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                            }
                        }
                        scanner.read();
                    } catch (ScannerException e) {
                        updateStatus(e.getMessage());
                    }
                }
                break;
            case WAITING:
                statusString = "Scanner is waiting for trigger press...";
                updateStatus(statusString);
                break;
            case SCANNING:
                statusString = "Scanning...";
                updateStatus(statusString);
                break;
            case DISABLED:
                statusString = statusData.getFriendlyName() + " is disabled.";
                updateStatus(statusString);
                break;
            case ERROR:
                statusString = "An error has occurred.";
                updateStatus(statusString);
                break;
            default:
                break;
        }
    }

    @Override
    public void onConnectionChange(ScannerInfo scannerInfo, ConnectionState connectionState) {
        String status;
        String scannerName = "";
        String statusExtScanner = connectionState.toString();
        String scannerNameExtScanner = scannerInfo.getFriendlyName();
        if (deviceList.size() != 0) {
            scannerName = deviceList.get(scannerIndex).getFriendlyName();
        }
        if (scannerName.equalsIgnoreCase(scannerNameExtScanner)) {
            switch (connectionState) {
                case CONNECTED:
                    bSoftTriggerSelected = false;
                    synchronized (lock) {
                        initScanner();
                        bExtScannerDisconnected = false;
                    }
                    break;
                case DISCONNECTED:
                    bExtScannerDisconnected = true;
                    synchronized (lock) {
                        deInitScanner();
                    }
                    break;
            }
            status = scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        } else {
            bExtScannerDisconnected = false;
            status = statusString + " " + scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        }
    }

    private void initScanner() {
        if (scanner == null) {
            if ((deviceList != null) && (deviceList.size() != 0)) {
                if (barcodeManager != null)
                    scanner = barcodeManager.getDevice(deviceList.get(scannerIndex));
            } else {
                updateStatus("Failed to get the specified scanner device! Please close and restart the application.");
                return;
            }
            if (scanner != null) {
                scanner.addDataListener(this);
                scanner.addStatusListener(this);
                try {
                    scanner.enable();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                    deInitScanner();
                }
            } else {
                updateStatus("Failed to initialize the scanner device.");
            }
        }
    }

    private void deInitScanner() {
        if (scanner != null) {
            try {
                scanner.disable();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try {
                scanner.removeDataListener(this);
                scanner.removeStatusListener(this);
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try {
                scanner.release();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }
            scanner = null;
        }
    }

    private void initBarcodeManager() {
        barcodeManager = (BarcodeManager) emdkManager.getInstance(FEATURE_TYPE.BARCODE);
        // Add connection listener
        if (barcodeManager != null) {
            barcodeManager.addConnectionListener(this);
        }
    }

    private void deInitBarcodeManager() {
        if (emdkManager != null) {
            emdkManager.release(FEATURE_TYPE.BARCODE);
        }
    }

    private void addSpinnerScannerDevicesListener() {
        spinnerScannerDevices.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View arg1, int position, long arg3) {
                if ((scannerIndex != position) || (scanner == null)) {
                    scannerIndex = position;
                    bSoftTriggerSelected = false;
                    bExtScannerDisconnected = false;
                    deInitScanner();
                    initScanner();
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
        });
    }

    private void enumerateScannerDevices() {
        if (barcodeManager != null) {
            List<String> friendlyNameList = new ArrayList<String>();
            int spinnerIndex = 0;
            deviceList = barcodeManager.getSupportedDevicesInfo();
            if ((deviceList != null) && (deviceList.size() != 0)) {
                Iterator<ScannerInfo> it = deviceList.iterator();
                while (it.hasNext()) {
                    ScannerInfo scnInfo = it.next();
                    friendlyNameList.add(scnInfo.getFriendlyName());
                    if (scnInfo.isDefaultScanner()) {
                        defaultIndex = spinnerIndex;
                    }
                    ++spinnerIndex;
                }
            } else {
                updateStatus("Failed to get the list of supported scanner devices! Please close and restart the application.");
            }
            ArrayAdapter<String> spinnerAdapter = new ArrayAdapter<String>(CommandesActivity.this, android.R.layout.simple_spinner_item, friendlyNameList);
            spinnerAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            spinnerScannerDevices.setAdapter(spinnerAdapter);
        }
    }

    private void setDecoders() {
        if (scanner != null) {
            try {
                ScannerConfig config = scanner.getConfig();
                // Set EAN8
                config.decoderParams.ean8.enabled = checkBoxEAN8.isChecked();
                // Set EAN13
                config.decoderParams.ean13.enabled = checkBoxEAN13.isChecked();
                // Set Code39
                config.decoderParams.code39.enabled = checkBoxCode39.isChecked();
                //Set Code128
                config.decoderParams.code128.enabled = checkBoxCode128.isChecked();
                scanner.setConfig(config);
            } catch (ScannerException e) {
                updateStatus(e.getMessage());
            }
        }
    }

    public void softScan(View view) {
        bSoftTriggerSelected = true;
        cancelRead();
    }

    private void cancelRead() {
        if (scanner != null) {
            if (scanner.isReadPending()) {
                try {
                    scanner.cancelRead();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                }
            }
            scanner.triggerType = TriggerType.SOFT_ONCE;
            try {
                scanner.read();
            } catch (ScannerException e) {
                e.printStackTrace();
            }
        }
    }

    private void updateStatus(final String status) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                textViewStatus.setText("" + status);
            }
        });
    }


    private void updateData(final String result) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if (result != null) {
                    if (!isOnline()) {
                        Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
                    } else {
                        //Si liste de produits inexistant, je recharge
                        if (listeAllProduits == null) {
                            try {
                                new GetAllProduitsAsyncTask().execute();
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        } else {
                            Produit p = getProduitFromCode128(result);
                            if (getCurrentFocus().getClass().getSimpleName().equals("SearchAutoComplete")) {
                                if (p != null && currentCommande != null) {
                                    Intent intent = new Intent(CommandesActivity.this, FicheProduitActivity.class);
                                    intent.putExtra("produit", p);
                                    startActivityForResult(intent, 3);
                                    searchBar.clearFocus();
                                } else if (currentCommande == null) {
                                    Toast.makeText(CommandesActivity.this, "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
                                } else if (p == null) {
                                    DialogProduitInexistant.show(CommandesActivity.this, 0);
                                }
                            } else {
                                if (p != null && currentCommande != null) {
                                    ajouterProduitCommande(p.getCode128(), p.getQuantite_pack());
                                } else if (currentCommande == null) {
                                    Toast.makeText(CommandesActivity.this, "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
                                } else if (p == null) {
                                    DialogProduitInexistant.show(CommandesActivity.this, 0);
                                }
                            }

                            if (dataLength++ > 100) { //Clear the cache after 100 scans
                                textViewData.setText("");
                                dataLength = 0;
                            }

                            textViewData.append(Html.fromHtml(result));
                            textViewData.append("\n");
                            findViewById(R.id.scrollViewData).post(new Runnable() {
                                public void run() {
                                    ((ScrollView) findViewById(R.id.scrollViewData)).fullScroll(View.FOCUS_DOWN);
                                }
                            });

                            //Permet de mettre à jour la commande en fonction des scans
                            //new UpdateCommandeAsyncTask().execute(); //Erreur 503 OVH
                        }
                    }
                }
            }
        });
    }


    public Produit getProduitFromCode128(String code128) {
        try {
            //Contrôler le stock uniquement lors de l'ajout d'un produit
            //new RefreshStockAsyncTask().execute();

            for (Produit p : listeAllProduits) {
                if (p.getCode128().equals(code128)) {
                    return p;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }


    public void ajouterProduitCommande(String code128, Integer qteProduit) {
        if (!isOnline()) {
            Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
        } else {
            int i = 0;
            int max = listeAllProduits.size();
            while (!listeAllProduits.get(i).getCode128().equals(code128) && i < max - 1) {
                i += 1;
            }
            if (i < max) {//si le produit existe dans la base de donnees
                int j = 0;
                int nbrProduitCommande = currentCommande.getListeProduit().size();
                Produit p = listeAllProduits.get(i);

                //new RefreshProduitAsyncTask().execute(p);

                while (nbrProduitCommande > 0 && !currentCommande.getListeProduit().get(j).getCode128().equals(p.getCode128()) && j < nbrProduitCommande - 1) {
                    j += 1;
                }

                int qte;
                if (currentCommande.getListeProduit().size() != 0) {
                    qte = currentCommande.getListeProduit().get(j).getQte();
                } else {
                    qte = 0;
                }

                int reste = p.getStock() - qte - p.getQte();

                if (j != nbrProduitCommande && nbrProduitCommande != 0 && currentCommande.getListeProduit().get(j).getCode128().equals(p.getCode128())) {
                    if (reste == 0) {
                        Toast.makeText(getApplicationContext(), "stock null", Toast.LENGTH_SHORT).show();
                        //currentCommande.getListeProduit().get(j).incQte();
                        int nouvelleQte = currentCommande.getListeProduit().get(j).getQte() + qteProduit;
                        Produit nouvelleQteProduit = currentCommande.getListeProduit().get(j);
                        nouvelleQteProduit.setQte(nouvelleQte);
                        currentCommande.delProduit(currentCommande.getListeProduit().get(j));
                        currentCommande.addProduit(nouvelleQteProduit);
                        //currentCommande.getListeProduit().get(j).setQte(currentCommande.getListeProduit().get(j).getQte()+qteProduit);
                    } else {
                        int nouvelleQte = currentCommande.getListeProduit().get(j).getQte() + qteProduit;
                        Produit nouvelleQteProduit = currentCommande.getListeProduit().get(j);
                        nouvelleQteProduit.setQte(nouvelleQte);
                        currentCommande.delProduit(currentCommande.getListeProduit().get(j));
                        currentCommande.addProduit(nouvelleQteProduit);
                        //currentCommande.getListeProduit().get(j).setQte(currentCommande.getListeProduit().get(j).getQte()+qteProduit);
                    }
                } else {
                    if (reste == 0) {
                        Toast.makeText(getApplicationContext(), "Stock null", Toast.LENGTH_SHORT).show();
                        Produit newProduit = new Produit(p);
                        newProduit.setQte(1);
                        currentCommande.addProduit(newProduit);
                    } else {
                        Produit newProduit = new Produit(p);
                        newProduit.setQte(p.getQte());
                        currentCommande.addProduit(newProduit);
                    }
                }
                //ITSEE Mise à jour en back-office
                //new UpdateCommandeAsyncTask().execute(); //Erreur 503 OVH

                afficheCommande();
            } else {
                DialogProduitInexistant.show(CommandesActivity.this, 0);
            }
        }
    }


    public void choixModeLivraison(View v) {
        if (currentCommande != null) {
            Intent intent = new Intent(CommandesActivity.this, ModeLivraisonActivity.class);
            intent.putExtra("commande", currentCommande);
            startActivityForResult(intent, 2);
        } else {
            Toast.makeText(CommandesActivity.this, "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
        }
    }

    /* ZEBRA */

    @Override
    public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
        bDecoderSettingsChanged = true;
        cancelRead();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    //Masquer le clavier quand on appuie en dehors du champ
    @Override
    public boolean dispatchTouchEvent(MotionEvent ev) {
        if (getCurrentFocus() != null) {
            InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(getCurrentFocus().getWindowToken(), 0);
        }
        return super.dispatchTouchEvent(ev);
    }

    public void faireRecherche(String valeur) {
        resultatRecherche = new ArrayList<>();
        if (!CommandesActivity.currentCommande.getListeProduit().isEmpty()) {
            Commande currentCommandeFiltre = new Commande();
            if (valeur.toLowerCase() != "") {
                for (Produit p : CommandesActivity.currentCommande.getListeProduit()) {
                    //Recherche sur la référence, couleur, catégorie, informations (nom catégorie) et non code 128
                    if (!p.getCode128().isEmpty() && p.getCode128().toLowerCase().contains(valeur.toLowerCase())) {
                        currentCommandeFiltre.addProduit(p);
                    } else if (!p.getRef().isEmpty() && p.getRef().toLowerCase().contains(valeur.toLowerCase())) {
                        currentCommandeFiltre.addProduit(p);
                    } else if (!p.getColoris().isEmpty() && p.getColoris().toLowerCase().contains(valeur.toLowerCase())) {
                        currentCommandeFiltre.addProduit(p);
                    } else if (!p.getInformations().isEmpty() && p.getInformations().toLowerCase().contains(valeur.toLowerCase())) {
                        currentCommandeFiltre.addProduit(p);
                    } else if (!p.getNumCategorie().isEmpty() && p.getNumCategorie().toLowerCase().contains(valeur.toLowerCase())) {
                        currentCommandeFiltre.addProduit(p);
                    }
                }
            } else {
                filtreRechercheEnCours = false;
            }
            if (currentCommandeFiltre.getQtetotal() == 0) {
                CommandesActivity.currentCommandeFiltre = CommandesActivity.currentCommande; //Remise à 0 si pas trouvé
            } else {
                CommandesActivity.currentCommandeFiltre = currentCommandeFiltre;
            }
        }
    }

    public static class UpdateCompleteCommandeAsyncTask extends AsyncTask<String, String, String> {
        private final String BASE_URL = MainActivity.backOfficeURL;
        private int success;

        @Override
        protected String doInBackground(String... params) {
            if (currentCommande != null) {
                HttpJsonParser httpJsonParser3 = new HttpJsonParser();
                Map<String, String> httpParams3 = new HashMap<>();
                httpParams3.put("numero_commande", currentCommande.getNum());
                JSONObject jsonObject3 = httpJsonParser3.makeHttpRequest(
                        BASE_URL + "updateCompleteCommande.php", "POST", httpParams3);
                try {
                    success = jsonObject3.getInt("success");
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }
            return null;
        }

    }

    public static class UpdateAnnulerCommandeAsyncTask extends AsyncTask<String, String, String> {
        private final String BASE_URL = MainActivity.backOfficeURL;
        private int success;

        @Override
        protected String doInBackground(String... params) {
            if (currentCommande != null) {
                HttpJsonParser httpJsonParser3 = new HttpJsonParser();
                Map<String, String> httpParams3 = new HashMap<>();
                httpParams3.put("numero_commande", currentCommande.getNum());
                JSONObject jsonObject3 = httpJsonParser3.makeHttpRequest(
                        BASE_URL + "updateAnnulerCommande.php", "POST", httpParams3);

                try {
                    success = jsonObject3.getInt("success");
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }
            return null;
        }

    }


    public class UpdateCommandeAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;
        ProgressDialog waiting;
        private int success;

        @Override
        protected String doInBackground(String... params) {
            if (currentCommande != null && currentCommande.getNum() != "" && !currentCommande.getListeProduit().isEmpty()) {
                HttpJsonParser httpJsonParser1 = new HttpJsonParser();
                Map<String, String> httpParams1 = new HashMap<>();
                httpParams1.put("num_commande", currentCommande.getNum());

                JSONObject jsonObject1 = httpJsonParser1.makeHttpRequest(
                        BASE_URL + "viderCommande.php", "POST", httpParams1);
                try {
                    success = jsonObject1.getInt("success");
                } catch (JSONException e) {
                    e.printStackTrace();
                }

                HttpJsonParser httpJsonParser = new HttpJsonParser();
                Map<String, String> httpParams = new HashMap<>();
                httpParams.put("num_commande", currentCommande.getNum());

                for (Produit p : currentCommande.getListeProduit()) {

                    httpParams.put("code128_produit", p.getCode128());
                    httpParams.put("quantite", String.valueOf(p.getQte()));
                    httpParams.put("prix", String.valueOf(p.getPrix()));

                    JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                            BASE_URL + "ajoutProduitCommande.php", "POST", httpParams);
                    try {
                        success = jsonObject.getInt("success");
                    } catch (JSONException e) {

                        e.printStackTrace();
                    }

                }

                HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                Map<String, String> httpParams2 = new HashMap<>();

                httpParams2.put("numero_commande", currentCommande.getNum());
                httpParams2.put("nom_client", currentCommande.getNomClient());
                httpParams2.put("mode_livraison", currentCommande.getModeLivraison());
                httpParams2.put("complete", "-1");
                httpParams2.put("remise_globale", String.valueOf(currentCommande.getRemiseGlobalePourcentage()));
                httpParams2.put("total_ht", String.valueOf(currentCommande.getPrixTotal()));
                httpParams2.put("total_fdp_ht", String.valueOf(currentCommande.getPrixTotal()));
                httpParams2.put("id_operateur", String.valueOf(currentCommande.getId_operateur()));
                JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                        BASE_URL + "updateCommande.php", "POST", httpParams2);
                try {
                    success = jsonObject2.getInt("success");
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);

            /*if (CommandesActivity.typeTicket == "rassemblee") {
                lancerTicketRassemble();
            } else if (CommandesActivity.typeTicket == "detaillee") {
                lancerTicketDetail();
            }*/

        }
    }

    //BASE DE DONNES
    private class GetAllProduitsAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected String doInBackground(String... params) {
            if (CommandesActivity.listeAllProduits == null) {
                HttpJsonParser httpJsonParser = new HttpJsonParser();
                JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                        BASE_URL + "listeProduits.php", "GET", null);
                List<Produit> produitList = new ArrayList<>();
                try {
                    int success = jsonObject.getInt("success");
                    JSONArray produits;
                    if (success == 1) {
                        produits = jsonObject.getJSONArray("data");
                        //Iterate through the response and populate produits list
                        for (int i = 0; i < produits.length(); i++) {
                            Produit p = new Produit();
                            JSONObject produit = produits.getJSONObject(i);

                            try {
                                p.setRef(produit.getString("reference"));
                                p.setColoris(produit.getString("coloris"));
                                p.setCommandable(produit.getString("commandable"));
                                p.setCode128(produit.getString("code_128"));
                                p.setQuantite_pack(produit.getInt("quantite_packs"));
                                p.setPrix(produit.getDouble("prix"));
                                p.setPrixPromo(produit.getDouble("prix_promo"));
                                p.setStock(produit.getInt("stock"));
                                p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                                p.setInformations(produit.getString("informations"));
                                p.setLien_image(produit.getString("lien_image"));
                                p.setActif(produit.getInt("actif"));
                                p.setQteTotalRef(produit.getInt("qte_total_ref"));
                                p.setQte(produit.getInt("quantite_packs"));
                                p.setSiPromo(0);
                                p.setNumCategorie(produit.getString("num_categorie"));
                                p.setSeuilMin(produit.getInt("seuil_min"));
                                p.setSeuilMax(produit.getInt("seuil_max"));
                                p.setPrixCatalogue(produit.getDouble("prix"));
                                produitList.add(p);

                            } catch (Exception e) {
                                e.printStackTrace();
                            }

                        }
                        CommandesActivity.listeAllProduits = produitList;
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            Toast.makeText(getApplicationContext(), "Sync effectué !", Toast.LENGTH_SHORT).show();
        }
    }

    private class DestockageProduitAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;
        ProgressDialog waiting;
        private int success;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            waiting = new ProgressDialog(CommandesActivity.this);
            waiting.setTitle("Destockage en cours ...");
            waiting.setMessage("Veuillez patienter");
            waiting.show();

            //new UpdateCompleteCommandeAsyncTask().execute(); //Finalisée

            //Impression à la fin
        }

        @Override
        protected String doInBackground(String... params) {

            if (currentCommande != null && !currentCommande.getListeProduit().isEmpty()) {
                HttpJsonParser httpJsonParser = new HttpJsonParser();
                Map<String, String> httpParams = new HashMap<>();

                //On forme le json à envoyer
                for (Produit p : currentCommande.getListeProduit()) {

                    httpParams.put("code128_produit", p.getCode128());
                    httpParams.put("quantite", String.valueOf(p.getQte()));

                    JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                            BASE_URL + "destockageProduit.php", "POST", httpParams);
                    try {
                        success = jsonObject.getInt("success");
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                }

            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);

            if (!CommandesActivity.this.isFinishing() && waiting != null) {
                waiting.dismiss();
            }

            listeCommande.set(selectedTab - 1, null);
            currentCommande = listeCommande.get(selectedTab - 1);
            mAdapter.setCmd(commandeVide);
            recyclerView.setAdapter(mAdapter);
            afficheCommande();
        }
    }

    public class RefreshProduitAsyncTask extends AsyncTask<Produit, String, String> {

        //BASE DE DONNEES
        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;

        @Override
        protected String doInBackground(Produit... produits) {
            Produit p = produits[0];

            HttpJsonParser httpJsonParser2 = new HttpJsonParser();
            Map<String, String> httpParams2 = new HashMap<>();

            httpParams2.put("code_128", p.getCode128());
            JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                    BASE_URL + "getStockProduit.php", "GET", httpParams2);

            try {
                success = jsonObject2.getInt("success");
                if (success == 1) {
                    JSONObject produit = jsonObject2.getJSONArray("data").getJSONObject(0);
                    p.setStock(Integer.parseInt(produit.getString("stock")));
                }

            } catch (JSONException e) {
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            mAdapter.notifyDataSetChanged();
        }
    }

    private class RefreshStockAsyncTask extends AsyncTask<String, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;
        //ProgressDialog waiting;
        private int success;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            //waiting = new ProgressDialog(CommandesActivity.this);
            //waiting.setTitle("Contrôle du stock");
            //waiting.setMessage("Veuillez patienter");
            //waiting.show();
        }

        @Override
        protected String doInBackground(String... params) {
            try {
                if (!currentCommande.getListeProduit().isEmpty()) {
                    for (Produit p : currentCommande.getListeProduit()) {
                        HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                        Map<String, String> httpParams2 = new HashMap<>();

                        httpParams2.put("code_128", p.getCode128());
                        JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                                BASE_URL + "getStockProduit.php", "GET", httpParams2);

                        try {
                            success = jsonObject2.getInt("success");
                            if (success == 1) {
                                JSONObject produit = jsonObject2.getJSONArray("data").getJSONObject(0);
                                p.setStock(Integer.parseInt(produit.getString("stock")));
                            }

                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            mAdapter.notifyDataSetChanged();
            //if (!CommandesActivity.this.isFinishing() && waiting != null) {
            //    waiting.dismiss();
            //}
        }
    }

    private class AddCommandeAsyncTask extends AsyncTask<String, String, String> {

        //BASE DE DONNEES
        private final String BASE_URL = MainActivity.backOfficeURL;
        private int success;
        private ProgressDialog waiting;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            //new GetAllProduitsAsyncTask().execute();

            waiting = new ProgressDialog(CommandesActivity.this);
            waiting.setTitle("Création de la commande en cours");
            waiting.setMessage("Veuillez patienter");
            waiting.show();

        }

        @Override
        protected String doInBackground(String... params) {

            DateFormat dateFormatForNumCommande = new SimpleDateFormat("yyMMdd");
            Date date = new Date();

            try {
                HttpJsonParser httpJsonParser = new HttpJsonParser();
                Map<String, String> httpParams = new HashMap<>();
                httpParams.put("date", newCommande.getDate());
                JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                        BASE_URL + "listeCommandeDate.php", "GET", httpParams);
                int nbrCommandeParDate = 0;
                int success = jsonObject.getInt("success");
                int nbrCommandesAjd;

                if (success == 1) {
                    nbrCommandesAjd = jsonObject.getInt("data");

                    nbrCommandeParDate = nbrCommandesAjd;
                    newCommande.setNum(dateFormatForNumCommande.format(date) + String.format("%03d", (nbrCommandeParDate + 1)));

                    try {
                        HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                        Map<String, String> httpParams2 = new HashMap<>();
                        //Populating request parameters
                        httpParams2.put("numero_commande", dateFormatForNumCommande.format(date) + String.format("%03d", (nbrCommandeParDate + 1)));
                        httpParams2.put("nom_client", "");
                        httpParams2.put("date_commande", "" + newCommande.getDate());
                        httpParams2.put("zone", "0");
                        httpParams2.put("mode_livraison", "aucun");
                        httpParams2.put("boutique", "" + IdentificationActivity.code_boutique);
                        httpParams2.put("total_ht", "" + "0.00");
                        httpParams2.put("total_fdp_ht", "0.00");
                        httpParams2.put("id_operateur", IdentificationActivity.id_operateur);
                        JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                                BASE_URL + "ajouterCommande.php", "POST", httpParams2);
                        success = jsonObject2.getInt("success");
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (!CommandesActivity.this.isFinishing() && waiting != null) {
                waiting.dismiss();
            }
            listeCommande.set(selectedTab - 1, newCommande);
            currentCommande = listeCommande.get(selectedTab - 1);
            mAdapter.setCmd(currentCommande);
            recyclerView.setAdapter(mAdapter);
            afficheCommande();
            Log.d("INFO", "ajout commande");
        }
    }

    private class VerifStockAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;
        private int success;
        private ProgressDialog waiting;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            waiting = new ProgressDialog(CommandesActivity.this);
            waiting.setTitle("Contrôle du stock");
            waiting.setMessage("Veuillez patienter");
            waiting.show();
        }

        @Override
        protected String doInBackground(String... params) {
            listeRupture = new ArrayList<>();
            if (currentCommande != null) {
                for (Produit p : currentCommande.getListeProduit()) {
                    HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                    Map<String, String> httpParams2 = new HashMap<>();

                    httpParams2.put("code_128", p.getCode128());
                    JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                            BASE_URL + "getStockProduit.php", "GET", httpParams2);

                    try {
                        success = jsonObject2.getInt("success");
                        if (success == 1) {
                            JSONObject produit = jsonObject2.getJSONArray("data").getJSONObject(0);
                            p.setStock(Integer.parseInt(produit.getString("stock")));
                        }

                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

                    if ((p.getStock() - p.getQte()) <= -1) { //Si aucun stock
                        listeRupture.add(p);
                    }
                }
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (!CommandesActivity.this.isFinishing() && waiting != null) {
                waiting.dismiss();
            }

            if (listeRupture.size() == 0) {
                //new DestockageProduitAsyncTask().execute();
            } else {
                AlertDialog.Builder builder = new AlertDialog.Builder(CommandesActivity.this);
                builder.setCancelable(true);
                builder.setTitle("Rupture de stock");

                String msg = "Les produits suivants ont un stock insuffisant, veillez à mettre à jour leurs quantités.\n";
                msg += " \n";
                for (Produit p : listeRupture) {
                    if (p.getStock() > 0) {
                        msg += p.getRef() + " " + p.getColoris() + " (" + p.getStock() + " restants)\n";
                    } else {
                        msg += p.getRef() + " " + p.getColoris() + " (" + p.getStock() + " restant)\n";
                    }
                }

                builder.setMessage(msg);
                builder.setPositiveButton("OK",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                            }
                        });
                AlertDialog dialog = builder.create();
                dialog.show();

            }
            //On décrémente du stock même si il n'y a pas de stock
            new DestockageProduitAsyncTask().execute();
        }
    }

}