package fr.itsee.zelyx;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.graphics.drawable.Drawable;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.provider.Settings;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.DividerItemDecoration;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.method.ScrollingMovementMethod;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.google.zxing.integration.android.IntentIntegrator;
import com.google.zxing.integration.android.IntentResult;
import com.squareup.picasso.Picasso;


import com.symbol.emdk.EMDKManager;
import com.symbol.emdk.EMDKManager.EMDKListener;
import com.symbol.emdk.EMDKManager.FEATURE_TYPE;
import com.symbol.emdk.EMDKResults;
import com.symbol.emdk.barcode.BarcodeManager;
import com.symbol.emdk.barcode.BarcodeManager.ConnectionState;
import com.symbol.emdk.barcode.BarcodeManager.ScannerConnectionListener;
import com.symbol.emdk.barcode.ScanDataCollection;
import com.symbol.emdk.barcode.Scanner;
import com.symbol.emdk.barcode.Scanner.DataListener;
import com.symbol.emdk.barcode.Scanner.StatusListener;
import com.symbol.emdk.barcode.Scanner.TriggerType;
import com.symbol.emdk.barcode.ScannerConfig;
import com.symbol.emdk.barcode.ScannerException;
import com.symbol.emdk.barcode.ScannerInfo;
import com.symbol.emdk.barcode.ScannerResults;
import com.symbol.emdk.barcode.StatusData;


import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.net.InetAddress;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import static fr.itsee.zelyx.CommandesActivity.dicImages;
import static fr.itsee.zelyx.CommandesActivity.filtreRechercheEnCours;
import static fr.itsee.zelyx.CommandesActivity.listeAllProduits;

/* ZEBRA */
public class ControleActivity extends AppCompatActivity implements EMDKListener, DataListener, StatusListener, ScannerConnectionListener, CompoundButton.OnCheckedChangeListener {
    //public class ControleActivity extends AppCompatActivity {

    public static Commande currentControle;
    public static List<Produit> currentListeAScanner;
    private final Object lock = new Object();
    List<Commande> listeControle = new ArrayList<>(3);
    List<List<Produit>> listeDeListeAScanner = new ArrayList<>(3);
    Button BarCodeCamera;
    private RecyclerView recyclerView;
    private ProduitAdapterControle mAdapter;
    private TextView date, num, nom, qteTotal, textQteTotal;
    private int selectedTab = 1;
    private List<Produit> listeVide;
    private String code128;
    /* ZEBRA */
    //Partie Scanner
    private EMDKManager emdkManager = null;
    private BarcodeManager barcodeManager = null;
    private Scanner scanner = null;
    private TextView textViewData = null;
    private TextView textViewStatus = null;
    private CheckBox checkBoxEAN8 = null;
    private CheckBox checkBoxEAN13 = null;
    private CheckBox checkBoxCode39 = null;
    private CheckBox checkBoxCode128 = null;
    private Spinner spinnerScannerDevices = null;
    /* ZEBRA */
    private List<ScannerInfo> deviceList = null;
    private int scannerIndex = 0; // Keep the selected scanner
    private int defaultIndex = 0; // Keep the default scanner
    private int dataLength = 0;
    private String statusString = "";
    //SCANNER EN PERMANENCE (bSoftTriggerSelected = TRUE)
    private boolean bSoftTriggerSelected = true;
    private boolean bDecoderSettingsChanged = false;
    private boolean bExtScannerDisconnected = false;

    private ImageView image_produit_full;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_controle_v2);

            if (android.provider.Settings.System.getInt(getContentResolver(),
                    Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
                setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
            } else {
                setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
            }

        date = findViewById(R.id.date);
        num = findViewById(R.id.num);
        nom = findViewById(R.id.nom);
        qteTotal = findViewById(R.id.qteTotal);
        textQteTotal = findViewById(R.id.textQteTotal);

        if (dicImages == null) {
            dicImages = new HashMap<>();
            new GetAllProduitsAsyncTask().execute();
        }


        mAdapter = new ProduitAdapterControle(new ArrayList<Produit>(), getApplicationContext());

        listeControle.add(null);
        listeControle.add(null);
        listeControle.add(null);

        listeVide = new ArrayList<>();

        listeDeListeAScanner.add(listeVide);
        listeDeListeAScanner.add(listeVide);
        listeDeListeAScanner.add(listeVide);

        //Permet de récupérer le backup de la vérification en cours
        getListeControles();
        getListeDeListeAScanner();

        recyclerView = findViewById(R.id.recycler_view);
        textViewData = findViewById(R.id.textViewData);
        textViewStatus = findViewById(R.id.textViewStatus);
        checkBoxEAN8 = findViewById(R.id.checkBoxEAN8);
        checkBoxEAN13 = findViewById(R.id.checkBoxEAN13);
        checkBoxCode39 = findViewById(R.id.checkBoxCode39);
        checkBoxCode128 = findViewById(R.id.checkBoxCode128);
        spinnerScannerDevices = findViewById(R.id.spinnerScannerDevices);

        RecyclerView.LayoutManager mLayoutManager = new LinearLayoutManager(getApplicationContext());
        recyclerView.setLayoutManager(mLayoutManager);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
        recyclerView.addItemDecoration(new DividerItemDecoration(this, LinearLayoutManager.VERTICAL));
        recyclerView.setAdapter(mAdapter);

        currentControle = listeControle.get(selectedTab - 1);
        currentListeAScanner = listeDeListeAScanner.get(selectedTab - 1);

        image_produit_full = findViewById(R.id.image_produit_full);

        if (currentControle == null) {
            afficheVide();
        } else {
            mAdapter.setListeProduit(currentListeAScanner);
            recyclerView.setAdapter(mAdapter);
            afficheControle();
        }

        mAdapter.setOnItemClickListener(new ProduitAdapterControle.OnItemClickListener() {

                                            @Override
                                            public void onPhotoClick(int position, Drawable imageDrawable, String lien_image) {
                                                if (filtreRechercheEnCours == false) {
                                                    Picasso.with(getApplicationContext()).load(MainActivity.backOfficeURLIMG + lien_image.replace(".jpg", "_full.jpg")).into(image_produit_full);
                                                    image_produit_full.setVisibility(View.VISIBLE);
                                                    image_produit_full.setEnabled(true);
                                                    image_produit_full.setAdjustViewBounds(true);
                                                } else {
                                                    Toast.makeText(getApplicationContext(), "Recherche en cours...", Toast.LENGTH_SHORT).show();
                                                }
                                            }
                                        });

        //permet de refermer la photo produit
        image_produit_full.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                    image_produit_full.setImageDrawable(null);
                    image_produit_full.setVisibility(View.INVISIBLE);
                    image_produit_full.setEnabled(false);
                    image_produit_full.setAdjustViewBounds(false);
            }
        });

        /* ZEBRA */
        deviceList = new ArrayList<ScannerInfo>();

        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);

        EMDKResults results = EMDKManager.getEMDKManager(getApplicationContext(), this);
        if (results.statusCode != EMDKResults.STATUS_CODE.SUCCESS) {
            updateStatus("EMDKManager object request failed!");
            return;
        }
        checkBoxEAN8.setOnCheckedChangeListener(this);
        checkBoxEAN13.setOnCheckedChangeListener(this);
        checkBoxCode39.setOnCheckedChangeListener(this);
        checkBoxCode128.setOnCheckedChangeListener(this);
        addSpinnerScannerDevicesListener();


        textViewData.setSelected(true);
        textViewData.setMovementMethod(new ScrollingMovementMethod());

        /* NON ZEBRA */
        //Scan camera
        BarCodeCamera = findViewById(R.id.btnScanner);
        final Activity activity = this;
        final Collection<String> PRODUCT_CODE_128 = Arrays.asList("CODE_128");
        BarCodeCamera.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!isOnline()) {
                    Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
                } else {
                    IntentIntegrator intentIntegrator = new IntentIntegrator(activity);
                    //intentIntegrator.setDesiredBarcodeFormats(intentIntegrator.ALL_CODE_TYPES);
                    intentIntegrator.setDesiredBarcodeFormats(PRODUCT_CODE_128);
                    intentIntegrator.setBeepEnabled(false);
                    intentIntegrator.setCameraId(0);
                    intentIntegrator.setPrompt("SCANNER LA COMMANDE A CONTROLER");
                    intentIntegrator.setBarcodeImageEnabled(false);
                    intentIntegrator.initiateScan();
                }
            }
        });

    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

    }

    protected boolean isOnline() {
        ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo netInfo = cm.getActiveNetworkInfo();
        return netInfo != null && netInfo.isConnectedOrConnecting();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        IntentResult Result = IntentIntegrator.parseActivityResult(requestCode, resultCode, data);
        if (Result != null) {
            if (Result.getContents() == null) {
                //Log.d("MainActivity" , "cancelled scan");
                Toast.makeText(this, "annulé", Toast.LENGTH_SHORT).show();
            } else {
                if (!isOnline()) {
                    Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
                } else {
                    updateData(Result.getContents());
                }
            }
        } else {
            super.onActivityResult(requestCode, resultCode, data);
        }
    }

    @Override
    protected void onStop() {
        super.onStop();
        saveListeControles();
        saveListeDeListeAScanner();
    }

    public void saveListeControles() {
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();
        sharedPreferences.edit().putString("listeControle", gson.toJson(listeControle)).apply();
    }

    public void getListeControles() {
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();

        String json = sharedPreferences.getString("listeControle", null);

        if (json != null) {
            listeControle = gson.fromJson(json, new TypeToken<List<Commande>>() {
            }.getType());
        }
    }

    public void saveListeDeListeAScanner() {
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();
        sharedPreferences.edit().putString("listeDeListeAScanner", gson.toJson(listeDeListeAScanner)).apply();
    }

    public void getListeDeListeAScanner() {
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();

        String json = sharedPreferences.getString("listeDeListeAScanner", null);

        if (json != null) {
            listeDeListeAScanner = gson.fromJson(json, new TypeToken<List<List<Produit>>>() {
            }.getType());
        }
    }

    public void afficheControle() {
        currentControle = listeControle.get(0);
        currentListeAScanner = listeDeListeAScanner.get(0);
        if (currentControle != null) {
            date.setText("Date: " + new SimpleDateFormat("dd-MM-yyyy", Locale.getDefault()).format(new Date()));
            num.setText("n°: " + currentControle.getNum());
            nom.setText(currentControle.getNomClient());
            textQteTotal.setText("Total pièces:");
            qteTotal.setText(String.valueOf(currentControle.getQtetotal()));
            mAdapter.setListeProduit(currentListeAScanner);
            mAdapter.notifyDataSetChanged();
        }
    }

    public void afficheVide() {
        date.setText("");
        num.setText("");
        nom.setText("Scannez une commande pour faire le contrôle");
        qteTotal.setText("");
        textQteTotal.setText("");
        mAdapter.notifyDataSetChanged();
    }

    /* ZEBRA */
    @Override
    public void onOpened(EMDKManager emdkManager) {
        updateStatus("EMDK open success!");
        this.emdkManager = emdkManager;
        // Acquire the barcode manager resources
        initBarcodeManager();
        // Enumerate scanner devices
        enumerateScannerDevices();
        // Set default scanner
        spinnerScannerDevices.setSelection(defaultIndex);
    }

    @Override
    protected void onResume() {
        super.onResume();

        //A la reprise de l'application, mettre à jour la liste des produits
        new GetAllProduitsAsyncTask().execute();

        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

        /* ZEBRA */


        // The application is in foreground
        if (emdkManager != null) {
            // Acquire the barcode manager resources
            initBarcodeManager();
            // Enumerate scanner devices
            enumerateScannerDevices();
            // Set selected scanner
            spinnerScannerDevices.setSelection(scannerIndex);
            // Initialize scanner
            initScanner();
        }

    }

    /* ZEBRA */

    @Override
    protected void onPause() {
        super.onPause();
        /* ZEBRA */

        // The application is in background
        // Release the barcode manager resources
        deInitScanner();
        deInitBarcodeManager();

    }

    @Override
    public void onClosed() {
        // Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
        updateStatus("EMDK closed unexpectedly! Please close and restart the application.");
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        saveListeControles();
        saveListeDeListeAScanner();
//         Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
    }

    @Override
    public void onData(ScanDataCollection scanDataCollection) {
        if ((scanDataCollection != null) && (scanDataCollection.getResult() == ScannerResults.SUCCESS)) {
            ArrayList<ScanDataCollection.ScanData> scanData = scanDataCollection.getScanData();
            for (ScanDataCollection.ScanData data : scanData) {
                updateData(data.getData());
            }
        }
    }

    @Override
    public void onStatus(StatusData statusData) {
        StatusData.ScannerStates state = statusData.getState();
        switch (state) {
            case IDLE:
                statusString = statusData.getFriendlyName() + " is enabled and idle...";
                updateStatus(statusString);
                // set trigger type
                if (bSoftTriggerSelected) {
                    //scanner.triggerType = TriggerType.SOFT_ONCE;
                    scanner.triggerType = TriggerType.SOFT_ALWAYS;
                    bSoftTriggerSelected = false;
                } else {
                    scanner.triggerType = TriggerType.HARD;
                }
                // set decoders
                if (bDecoderSettingsChanged) {
                    setDecoders();
                    bDecoderSettingsChanged = false;
                }
                // submit read
                if (!scanner.isReadPending() && !bExtScannerDisconnected) {
                    try {
                        scanner.read();
                    } catch (ScannerException e) {
                        updateStatus(e.getMessage());
                    }
                }
                break;
            case WAITING:
                statusString = "Scanner is waiting for trigger press...";
                updateStatus(statusString);
                break;
            case SCANNING:
                statusString = "Scanning...";
                updateStatus(statusString);
                break;
            case DISABLED:
                statusString = statusData.getFriendlyName() + " is disabled.";
                updateStatus(statusString);
                break;
            case ERROR:
                statusString = "An error has occurred.";
                updateStatus(statusString);
                break;
            default:
                break;
        }
    }

    @Override
    public void onConnectionChange(ScannerInfo scannerInfo, ConnectionState connectionState) {
        String status;
        String scannerName = "";
        String statusExtScanner = connectionState.toString();
        String scannerNameExtScanner = scannerInfo.getFriendlyName();
        if (deviceList.size() != 0) {
            scannerName = deviceList.get(scannerIndex).getFriendlyName();
        }
        if (scannerName.equalsIgnoreCase(scannerNameExtScanner)) {
            switch (connectionState) {
                case CONNECTED:
                    bSoftTriggerSelected = false;
                    synchronized (lock) {
                        initScanner();
                        bExtScannerDisconnected = false;
                    }
                    break;
                case DISCONNECTED:
                    bExtScannerDisconnected = true;
                    synchronized (lock) {
                        deInitScanner();
                    }
                    break;
            }
            status = scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        } else {
            bExtScannerDisconnected = false;
            status = statusString + " " + scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        }
    }

    private void initScanner() {
        if (scanner == null) {
            if ((deviceList != null) && (deviceList.size() != 0)) {
                if (barcodeManager != null)
                    scanner = barcodeManager.getDevice(deviceList.get(scannerIndex));
            } else {
                updateStatus("Failed to get the specified scanner device! Please close and restart the application.");
                return;
            }
            if (scanner != null) {
                scanner.addDataListener(this);
                scanner.addStatusListener(this);
                try {
                    scanner.enable();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                    deInitScanner();
                }
            } else {
                updateStatus("Failed to initialize the scanner device.");
            }
        }
    }

    private void deInitScanner() {
        if (scanner != null) {
            try {
                scanner.disable();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try {
                scanner.removeDataListener(this);
                scanner.removeStatusListener(this);
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try {
                scanner.release();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }
            scanner = null;
        }
    }

    private void initBarcodeManager() {
        barcodeManager = (BarcodeManager) emdkManager.getInstance(FEATURE_TYPE.BARCODE);
        // Add connection listener
        if (barcodeManager != null) {
            barcodeManager.addConnectionListener(this);
        }
    }

    private void deInitBarcodeManager() {
        if (emdkManager != null) {
            emdkManager.release(FEATURE_TYPE.BARCODE);
        }
    }

    private void addSpinnerScannerDevicesListener() {
        spinnerScannerDevices.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View arg1, int position, long arg3) {
                if ((scannerIndex != position) || (scanner == null)) {
                    scannerIndex = position;
                    bSoftTriggerSelected = false;
                    bExtScannerDisconnected = false;
                    deInitScanner();
                    initScanner();
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
        });
    }

    private void enumerateScannerDevices() {
        if (barcodeManager != null) {
            List<String> friendlyNameList = new ArrayList<String>();
            int spinnerIndex = 0;
            deviceList = barcodeManager.getSupportedDevicesInfo();
            if ((deviceList != null) && (deviceList.size() != 0)) {
                Iterator<ScannerInfo> it = deviceList.iterator();
                while (it.hasNext()) {
                    ScannerInfo scnInfo = it.next();
                    friendlyNameList.add(scnInfo.getFriendlyName());
                    if (scnInfo.isDefaultScanner()) {
                        defaultIndex = spinnerIndex;
                    }
                    ++spinnerIndex;
                }
            } else {
                updateStatus("Failed to get the list of supported scanner devices! Please close and restart the application.");
            }
            ArrayAdapter<String> spinnerAdapter = new ArrayAdapter<String>(ControleActivity.this, android.R.layout.simple_spinner_item, friendlyNameList);
            spinnerAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            spinnerScannerDevices.setAdapter(spinnerAdapter);
        }
    }

    private void setDecoders() {
        if (scanner != null) {
            try {
                ScannerConfig config = scanner.getConfig();
                // Set EAN8
                config.decoderParams.ean8.enabled = checkBoxEAN8.isChecked();
                // Set EAN13
                config.decoderParams.ean13.enabled = checkBoxEAN13.isChecked();
                // Set Code39
                config.decoderParams.code39.enabled = checkBoxCode39.isChecked();
                //Set Code128
                config.decoderParams.code128.enabled = checkBoxCode128.isChecked();
                scanner.setConfig(config);
            } catch (ScannerException e) {
                updateStatus(e.getMessage());
            }
        }
    }

    public void softScan(View view) {
        bSoftTriggerSelected = true;
        cancelRead();
    }

    private void cancelRead() {
        if (scanner != null) {
            if (scanner.isReadPending()) {
                try {
                    scanner.cancelRead();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                }
            }
        }
    }

    private void updateStatus(final String status) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                textViewStatus.setText("" + status);
            }
        });
    }

    private void updateData(final String result) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if (result != null) {
                    if (!isOnline()) {
                        Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
                    } else {
                        if (currentControle == null) {
                            code128 = result;
                            new GetCommandeAsyncTask().execute();
                        } else {
                            produitScanner(result);
                        }
                    }
                }
            }
        });
    }

    public int getProduitPos(String result) {
        int cpt = 0;
        if (currentControle != null) {
            for (Produit p : currentListeAScanner) {
                if (p.getCode128().equals(result)) {
                    return cpt;
                }
                cpt += 1;
            }
        }
        return cpt;
    }

    public void controlerNouvelleCommande(View v) {
        currentControle = null;
        listeControle.set(selectedTab - 1, null);
        listeDeListeAScanner.set(selectedTab - 1, listeVide);
        currentListeAScanner = listeDeListeAScanner.get(selectedTab - 1);
        mAdapter.setListeProduit(currentListeAScanner);
        afficheVide();
    }

    public void vider() {
        for (int i = 0; i < currentListeAScanner.size(); i++) {
            recyclerView.findViewHolderForAdapterPosition(i).itemView.setBackgroundColor(Color.WHITE);
        }
        currentControle = null;
        listeControle.set(selectedTab - 1, null);
        listeDeListeAScanner.set(selectedTab - 1, listeVide);
        currentListeAScanner = listeDeListeAScanner.get(selectedTab - 1);
        mAdapter.setListeProduit(currentListeAScanner);
        afficheVide();
    }

    public void newControle(View v) {
        if (isAllScanned()) {
            vider();
        } else {
            final Activity activity = this;
            final Collection<String> PRODUCT_CODE_128 = Arrays.asList("CODE_128");
            BarCodeCamera.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if (!isOnline()) {
                        Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
                    } else {
                        IntentIntegrator intentIntegrator = new IntentIntegrator(activity);
                        //intentIntegrator.setDesiredBarcodeFormats(intentIntegrator.ALL_CODE_TYPES);
                        intentIntegrator.setDesiredBarcodeFormats(PRODUCT_CODE_128);
                        intentIntegrator.setBeepEnabled(false);
                        intentIntegrator.setCameraId(0);
                        intentIntegrator.setPrompt("SCANNER LE PRODUIT");
                        intentIntegrator.setBarcodeImageEnabled(false);
                        intentIntegrator.initiateScan();
                    }
                }
            });
            DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    switch (which) {
                        case DialogInterface.BUTTON_POSITIVE:
                            //No button clicked
                            dialog.dismiss();
                            break;

                        case DialogInterface.BUTTON_NEGATIVE:
                            //Yes button clicked
                            dialog.dismiss();
                            vider();
                            break;
                    }
                }
            };

            AlertDialog.Builder builder = new AlertDialog.Builder(this);
            builder.setMessage("Tout les produits n'ont pas été scanné, voulez-vous vraiment quitter ?");
            builder.setNegativeButton("OUI", dialogClickListener);
            builder.setPositiveButton("NON", dialogClickListener);
            builder.show();
        }
    }


    public void produitScanner(String code128) {
        int i = getProduitPos(code128);
        int max = currentListeAScanner.size();
        if (i < max) {
            Produit p = currentListeAScanner.get(i);
            if (p.getNbrScanner() < p.getQte()) {
                p.setNbrScanner(p.getNbrScanner() + 1);
                if (isAllScanned() && currentListeAScanner.size() != 0) {
                    final Dialog myDialog = new Dialog(this);
                    myDialog.setContentView(R.layout.popup_ok);

                    Button b = myDialog.findViewById(R.id.txt);
                    b.setText("OK");
                    b.setBackground(getDrawable(R.drawable.rounded_corner));
                    b.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View view) {
                            myDialog.dismiss();

                        }
                    });
                    myDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
                    myDialog.show();

                    new UpdateCommandeCompleteAsyncTask().execute();
                }
            } else if (p.getNbrScanner() >= p.getQte()) {
                p.setNbrScanner(p.getNbrScanner() + 1);
                afficheCroixRouge();
            }
            afficheControle();
        } else {
            afficheCroixRouge();
        }
    }

    public void afficheCroixRouge() {
        final Dialog myDialog = new Dialog(this);
        myDialog.setContentView(R.layout.popup_ok);
        Button b = myDialog.findViewById(R.id.txt);
        b.setText("X");
        b.setBackground(getDrawable(R.drawable.rounded_corner_x));
        myDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        // Hide after some seconds
        final Handler handler = new Handler();
        final Runnable runnable = new Runnable() {
            @Override
            public void run() {
                if (myDialog.isShowing()) {
                    myDialog.dismiss();
                }
            }
        };

        myDialog.setOnDismissListener(new DialogInterface.OnDismissListener() {
            @Override
            public void onDismiss(DialogInterface dialog) {
                handler.removeCallbacks(runnable);
            }
        });
        handler.postDelayed(runnable, 1000);
        myDialog.show();
    }


    public boolean isAllScanned() {
        int cptScanner = 0;
        int cptTot = 0;
        if (currentListeAScanner != null) {
            for (Produit p : currentListeAScanner) {
                cptScanner += p.getNbrScanner();
                cptTot += p.getQte();
            }
        }
        return cptTot == cptScanner;
    }

    /* ZEBRA */
    @Override
    public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
        bDecoderSettingsChanged = true;
        cancelRead();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }
        return super.onOptionsItemSelected(item);
    }


    //BASE DE DONNES

    @Override
    protected void onRestart() {
        super.onRestart();
    }

    //Masquer le clavier quand on appuie en dehors du champ
    @Override
    public boolean dispatchTouchEvent(MotionEvent ev) {
        if (getCurrentFocus() != null) {
            InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(getCurrentFocus().getWindowToken(), 0);
        }
        return super.dispatchTouchEvent(ev);
    }

    private class GetCommandeAsyncTask extends AsyncTask<String, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;
        private Boolean dejaFaite = false;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            nom.setText("Récupération de la commande en cours...");

        }

        @Override
        protected String doInBackground(String... params) {

            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams = new HashMap<>();
            httpParams.put("numero_commande", code128);

            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "getCommande.php", "GET", httpParams);
            try {
                int success = jsonObject.getInt("success");

                if (success == 1) {
                    JSONObject commande = jsonObject.getJSONArray("data").getJSONObject(0);
                    if (commande.getInt("complete") == 3) {
                        dejaFaite = true;
                    } else {

                        currentControle = new Commande();
                        currentControle.setNum(commande.getString("numero_commande"));
                        currentControle.setNomClient(commande.getString("nom_client"));
                        currentControle.setDate(commande.getString("date_commande"));
                        currentControle.setQtetotal(0);
                        currentControle.setPrixTotal(0);
                        currentControle.setModeLivraison(commande.getString("mode_livraison"));


                        //recuperation des produits de la commande
                        HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                        Map<String, String> httpParams2 = new HashMap<>();
                        httpParams2.put("num_commande", code128);
                        JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                                BASE_URL + "listeProduitsCommande.php", "GET", httpParams2);

                        List<Produit> produitList = new ArrayList<>();

                        try {
                            int success2 = jsonObject2.getInt("success");
                            JSONArray produits;
                            if (success2 == 1) {
                                produits = jsonObject2.getJSONArray("data");
                                //Iterate through the response and populate produits list
                                    for (int i = 0; i < produits.length(); i++) {
                                        Produit p = new Produit();
                                        JSONObject produit = produits.getJSONObject(i);

                                        try {
                                            p.setRef(produit.getString("reference"));
                                            p.setColoris(produit.getString("coloris"));
                                            p.setCommandable(produit.getString("commandable"));
                                            p.setCode128(produit.getString("code_128"));
                                            p.setQuantite_pack(produit.getInt("quantite_packs"));
                                            p.setPrix(produit.getDouble("prix"));
                                            p.setStock(produit.getInt("stock"));
                                            p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                                            p.setInformations(produit.getString("informations"));
                                            p.setLien_image(produit.getString("lien_image"));
                                            p.setActif(produit.getInt("actif"));
                                            p.setQte(produit.getInt("quantite"));
                                            p.setNbrScanner(0);
                                            produitList.add(p);
                                        } catch (Exception e) {
                                            e.printStackTrace();
                                        }
                                    }
                                try {
                                    currentControle.setListeProduit(produitList);
                                    listeControle.set(selectedTab - 1, currentControle);

                                    Collections.sort(currentControle.getListeProduit());
                                    listeDeListeAScanner.set(selectedTab - 1, currentControle.getListeProduit());

                                } catch (Exception e) {
                                    e.printStackTrace();
                                }

                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (currentControle == null) {
                if (dejaFaite == true) {
                    AlertDialog.Builder alertDialog = new AlertDialog.Builder(ControleActivity.this);
                    alertDialog.setMessage("Cette commande a déjà été contrôlée.");
                    alertDialog.setPositiveButton("OK", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int whichButton) {
                            dialog.dismiss();
                        }
                    });
                    alertDialog.show();
                }
                afficheVide();
            } else {
                afficheControle();
            }
        }
    }

    private class UpdateCommandeCompleteAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

        }

        @Override
        protected String doInBackground(String... params) {

            HttpJsonParser httpJsonParser2 = new HttpJsonParser();
            Map<String, String> httpParams2 = new HashMap<>();

            httpParams2.put("numero_commande", currentControle.getNum());
            JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                    BASE_URL + "updateCompleteCommande.php", "POST", httpParams2);
            try {
                success = jsonObject2.getInt("success");
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }
    }

    private class GetAllProduitsAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;


        @Override
        protected void onPreExecute() {
            super.onPreExecute();

        }

        @Override
        protected String doInBackground(String... params) {
            if (listeAllProduits == null) {
                HttpJsonParser httpJsonParser = new HttpJsonParser();
                JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                        BASE_URL + "listeProduits.php", "GET", null);
                List<Produit> produitList = new ArrayList<>();
                try {
                    int success = jsonObject.getInt("success");
                    JSONArray produits;
                    if (success == 1) {
                        produits = jsonObject.getJSONArray("data");
                        for (int i = 0; i < produits.length(); i++) {
                            Produit p = new Produit();
                            JSONObject produit = produits.getJSONObject(i);
                            try {
                                p.setRef(produit.getString("reference"));
                                p.setColoris(produit.getString("coloris"));
                                p.setCommandable(produit.getString("commandable"));
                                p.setCode128(produit.getString("code_128"));
                                p.setQuantite_pack(produit.getInt("quantite_packs"));
                                p.setPrix(produit.getDouble("prix"));
                                p.setStock(produit.getInt("stock"));
                                p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                                p.setInformations(produit.getString("informations"));
                                p.setLien_image(produit.getString("lien_image"));
                                p.setActif(produit.getInt("actif"));
                                p.setQte(1);

                                produitList.add(p);

                            } catch (Exception e) {
                                e.printStackTrace();
                            }

                        }
                        listeAllProduits = produitList;
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);

        }
    }

}
