package fr.itsee.zelyx;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.provider.Settings;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.epson.epos2.Epos2Exception;
import com.epson.epos2.Log;
import com.epson.epos2.printer.Printer;
import com.epson.epos2.printer.PrinterStatusInfo;
import com.epson.epos2.printer.ReceiveListener;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class PrinterActivity extends Activity implements ReceiveListener {

    private static final int REQUEST_PERMISSION = 100;
    public static Commande currentControle;
    public static List<Produit> currentListeAScanner;
    public String ligneProduitsRassemblee = "";
    public Double ligneProduitsRassembleeTotal = 0.0;
    public Integer ligneProduitsRassembleeTotalQte = 0;
    List<Commande> listeControle = new ArrayList<>(1);
    List<List<Produit>> listeDeListeAScanner = new ArrayList<>(1);
    private Commande commande;
    private String numero_commande;
    private String typeticket;
    private Context mContext = null;
    private EditText mEditTarget = null;
    private Spinner mSpnSeries = null;
    private Spinner mSpnLang = null;
    private Printer mPrinter = null;
    private Button btnSampleReceipt;
    private TextView textView, resultprint;
    private List<Produit> listeVide;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_print);

        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }
        //Permet de ne pas afficher la vue :)

        //new CommandesActivity.UpdateCommandeAsyncTask().execute();

        btnSampleReceipt = findViewById(R.id.btnSampleReceipt);

        mEditTarget = findViewById(R.id.edtTarget);

        textView = findViewById(R.id.textView);

        //Récupération de la MAC depuis la base de données
        mEditTarget.setText("TCP:" + IdentificationActivity.mac_imprimante);

        requestRuntimePermission();

        mContext = this;

        mSpnSeries = findViewById(R.id.spnModel);
        ArrayAdapter<SpnModelsItem> seriesAdapter = new ArrayAdapter<SpnModelsItem>(this, android.R.layout.simple_spinner_item);
        seriesAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_m10), Printer.TM_M10));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_m30), Printer.TM_M30));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_p20), Printer.TM_P20));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_p60), Printer.TM_P60));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_p60ii), Printer.TM_P60II));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_p80), Printer.TM_P80));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t20), Printer.TM_T20));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t60), Printer.TM_T60));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t70), Printer.TM_T70));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t81), Printer.TM_T81));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t82), Printer.TM_T82));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t83), Printer.TM_T83));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t83iii), Printer.TM_T83III));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t88), Printer.TM_T88));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t90), Printer.TM_T90));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t90kp), Printer.TM_T90KP));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_t100), Printer.TM_T100));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_u220), Printer.TM_U220));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_u330), Printer.TM_U330));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_l90), Printer.TM_L90));
        seriesAdapter.add(new SpnModelsItem(getString(R.string.printerseries_h6000), Printer.TM_H6000));

        mSpnSeries.setAdapter(seriesAdapter);
        mSpnSeries.setSelection(1);

        mSpnLang = findViewById(R.id.spnLang);
        ArrayAdapter<SpnModelsItem> langAdapter = new ArrayAdapter<SpnModelsItem>(this, android.R.layout.simple_spinner_item);
        langAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        langAdapter.add(new SpnModelsItem(getString(R.string.lang_french), Printer.MODEL_ANK));

        mSpnLang.setAdapter(langAdapter);
        mSpnLang.setSelection(0);


        try {
            Log.setLogSettings(mContext, Log.PERIOD_TEMPORARY, Log.OUTPUT_STORAGE, null, 0, 1, Log.LOGLEVEL_LOW);
        } catch (Exception e) {
            ShowMsg.showException(e, "setLogSettings", mContext);
        }


        Intent intent = getIntent();
        //Récupération de la commande
        commande = intent.getParcelableExtra("commande");
        typeticket = intent.getStringExtra("typeticket");



        numero_commande = commande.getNum();

        Collections.sort(commande.getListeProduit());

        //Si Ticket "détaillé"
        if (typeticket.equals("detaillee")) {
            runTicketDetaille();
        } else if (typeticket.equals("rassemblee")) {
            new GetTicketRassembleeDonneesAsyncTask().execute();
            //GetTicketRassemblee... appel après runTicketRassemblee();
        }

        //ITSEE Ferme la vue après impression
        finish();
    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

    }


    @Override
    protected void onActivityResult(int requestCode, final int resultCode, final Intent data) {
        if (data != null && resultCode == RESULT_OK) {
            String target = data.getStringExtra(getString(R.string.title_target));
            if (target != null) {
                EditText mEdtTarget = findViewById(R.id.edtTarget);
                mEdtTarget.setText(target);
            }

        }
    }

    public void btnDiscovery(View v) {
        Intent intent = new Intent(this, DiscoveryActivity.class);
        startActivityForResult(intent, 0);
    }

    public void btnSampleReceipt(View v) {
        updateButtonState(false);
        if (!runPrintReceiptSequence()) {
            updateButtonState(true);
        }
    }

    public void btnSampleCoupon(View v) {
        updateButtonState(false);
        if (!runPrintCouponSequence()) {
            updateButtonState(true);
        }
    }

    //Exemple ticket
    private boolean runPrintReceiptSequence() {
        if (!initializeObject()) {
            return false;
        }

        if (!createReceiptData()) {
            finalizeObject();
            return false;
        }

        if (!printData()) {
            finalizeObject();
            return false;
        }

        return true;
    }

    private boolean runTicketDetaille() {
        if (!initializeObject()) {
            return false;
        }

        if (!createTicketDetaille()) {
            finalizeObject();
            return false;
        }

        if (!printData()) {
            finalizeObject();
            return false;
        }

        return true;
    }

    private boolean runTicketRassemblee(String s) {
        if (!initializeObject()) {
            return false;
        }

        if (!createTicketRassemblee(s)) {
            finalizeObject();
            return false;
        }

        if (!printData()) {
            finalizeObject();
            return false;
        }

        return true;
    }

    //Ticket Rassemblée
    public double getPrixTotalRef(String ref) {
        double tot = 0;
        for (Produit p : commande.getListeProduit()) {
            if (p.getRef().equals(ref)) {
                tot += p.getPrix() * p.getQte();
            }
        }
        return tot;
    }

    private boolean createReceiptData() {

        String method = "";
        StringBuilder textData = new StringBuilder();


        Bitmap zelyx = BitmapFactory.decodeResource(getResources(), R.drawable.zelyx);
        final int barcodeWidth = 2;
        final int barcodeHeight = 64;
        final int pageAreaHeight = 500;
        final int pageAreaWidth = 500;
        final int fontAHeight = 24;
        final int fontAWidth = 12;
        final int barcodeWidthPos = 120;
        final int barcodeHeightPos = 70;


        if (mPrinter == null) {
            return false;
        }

        try {

            //TICKET 1
            method = "addTextAlign";
            mPrinter.addTextAlign(Printer.ALIGN_CENTER);

            mPrinter.addTextSize(1, 1);
            method = "addFeedLine";
            mPrinter.addFeedLine(1);
            textData.append("  \n");


            method = "addImage";
            mPrinter.addImage(zelyx, 0, 0, zelyx.getWidth(), zelyx.getHeight(), Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 3, Printer.PARAM_DEFAULT);

            textData.append("LISTE DE COLISAGE\n");
            textData.append("CLIENT: " + commande.getNomClient() + "\n");

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());


            method = "addBarcode";

            mPrinter.addBarcode("{A" + numero_commande, Printer.BARCODE_CODE128, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 2, 64);

            textData.append("\n");

            method = "addTextAlign";
            mPrinter.addTextAlign(Printer.ALIGN_LEFT);
            textData.append("DATE: " + commande.getDate() + "               N°" + numero_commande + "\n");
            textData.append("------------------------------------------------\n");


            textData.append(String.format("%-16s", "REF") + String.format("%-6s", "QTE") + String.format("%-10s", "PU HT") + String.format("%-15s", "MONTANT") + "\n");

            //mPrinter.addTextAlign(Printer.ALIGN_LEFT);

            String oldRef = "";

            DecimalFormat df = new DecimalFormat("0.00");

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            String prixAligneDroite = "";

            for (Produit p : commande.getListeProduit()) {
                if (oldRef.equals(p.getRef())) {
                    //if (p.getStock() - p.getQte() <= 2) {
                    //    mPrinter.addTextStyle(0, 0, 0, 0);
                    //    textData.append(String.format("%-16s", p.getColoris()) + String.format("%-6s", p.getQte() + "*    " + p.getNumero_de_rayon()) + "\n");
                    //    mPrinter.addText(textData.toString());
                    //    textData.delete(0, textData.length());
                    //} else {
                    //SUPPRESSION DE L'ETOILE DE LA QUANTITE
                    mPrinter.addTextStyle(0, 0, 0, 0);
                    textData.append(String.format("%-16s", p.getColoris()) + String.format("%-6s", p.getQte() + "     " + p.getNumero_de_rayon()) + "\n");
                    mPrinter.addText(textData.toString());
                    textData.delete(0, textData.length());
                    //}
                } else {
                    textData.append("------------------------------------------------\n");
                    System.out.println(getPrixTotalRef(p.getRef()));
                    mPrinter.addTextStyle(0, 0, 1, 0);
                    //if (p.getSiPromo() == 1 || (p.getPrix() != p.getPrixCatalogue())) {
                    //    textData.append(String.format("%-16s", p.getRef()) + String.format("%6s", getQteRef(p.getRef())) + "*" + String.format("%10s", p.getPrixPromo()) + String.format("%-15s", df.format(getPrixTotalRef(p.getRef()))) + "\n");
                    //} else {
                    textData.append(String.format("%-16s", p.getRef()) + String.format("%6s", getQteRef(p.getRef())) + String.format("%10s", p.getPrix()) + String.format("%-15s", df.format(getPrixTotalRef(p.getRef()))) + "\n");
                    //}
                    mPrinter.addText(textData.toString());
                    textData.delete(0, textData.length());

                    //if (p.getStock() - p.getQte() <= 2) {
                    //    mPrinter.addTextStyle(0, 0, 0, 0);
                    //    textData.append(String.format("%-16s", p.getColoris()) + String.format("%-6s", p.getQte() + "*    " + p.getNumero_de_rayon()) + "\n");
                    //    mPrinter.addText(textData.toString());
                    //    textData.delete(0, textData.length());
                    //} else {
                    //SUPPRESSION DE L'ETOILE SUR LA QUANTITE
                    mPrinter.addTextStyle(0, 0, 0, 0);
                    textData.append(String.format("%-16s", p.getColoris()) + String.format("%6s", p.getQte() + "     " + p.getNumero_de_rayon()) + "\n");
                    mPrinter.addText(textData.toString());
                    textData.delete(0, textData.length());
                    //}
                }
                oldRef = p.getRef();
            }


            textData.delete(0, textData.length());
            mPrinter.addTextStyle(0, 0, 0, 0);

            textData.append("------------------------------------------------\n");

            if (commande.getRemiseGlobalePourcentage() > 0) {
                textData.append(String.format("%-18s", "") + String.format("%30s", "REMISE ("+df.format(commande.getRemiseGlobalePourcentage())+"%): " + df.format(commande.getRemiseTotal()) + "\n"));
                textData.append("\n");
                textData.append(String.format("%-18s", "Qté TOTAL: " + commande.getQtetotal()) + String.format("%30s", "TOTAL HT: " + df.format(commande.getPrixTotalAvecRemise()) + "\n"));
                textData.append("\n");
            } else {
                textData.append(String.format("%-18s", "Qté TOTAL: " + commande.getQtetotal()) + String.format("%30s", "TOTAL HT: " + df.format(commande.getPrixTotal())) + "\n");
                textData.append("\n");
            }
            textData.append("TRANSPORTEUR: " + commande.getModeLivraison() + "\n");
            method = "addText";
            textData.append("\n");
            textData.append("\n");
            textData.append("Note: " + "\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            mPrinter.addText(textData.toString());


            method = "addCut";
            mPrinter.addCut(Printer.CUT_FEED);
            textData.delete(0, textData.length());

        } catch (Exception e) {
            ShowMsg.showException(e, method, mContext);
            return false;
        }
        textData = null;
        return true;
    }

    private boolean createTicketDetaille() {

        String method = "";
        Bitmap logoData = BitmapFactory.decodeResource(getResources(), R.drawable.photo_test);
        StringBuilder textData = new StringBuilder();


        Bitmap zelyx = BitmapFactory.decodeResource(getResources(), R.drawable.zelyx);
        final int barcodeWidth = 2;
        final int barcodeHeight = 64;
        final int pageAreaHeight = 500;
        final int pageAreaWidth = 500;
        final int fontAHeight = 24;
        final int fontAWidth = 12;
        final int barcodeWidthPos = 120;
        final int barcodeHeightPos = 70;


        if (mPrinter == null) {
            return false;
        }

        try {

            DecimalFormat df = new DecimalFormat("0.00");

            //TICKET 1
            method = "addTextAlign";
            mPrinter.addTextAlign(Printer.ALIGN_CENTER);

            mPrinter.addTextSize(1, 1);
            method = "addFeedLine";
            mPrinter.addFeedLine(1);
            //textData.append("  \n");


            //method = "addImage";
            //mPrinter.addImage(zelyx, 0, 0, zelyx.getWidth(), zelyx.getHeight(), Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 3, Printer.PARAM_DEFAULT);

            textData.append("LISTE DE COLISAGE\n");
            textData.append("N° " + numero_commande + "\n");


            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            method = "addBarcode";

            mPrinter.addBarcode("{A" + numero_commande, Printer.BARCODE_CODE128, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 2, 64);

            textData.append("\n");

            textData.append("CLIENT: " + commande.getNomClient() + "\n");

            mPrinter.addTextAlign(Printer.ALIGN_LEFT);
            textData.append("DATE: " + commande.getDate().replace("/", "-") + "\n");
            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            mPrinter.addTextAlign(Printer.ALIGN_RIGHT);
            textData.append(IdentificationActivity.code_boutique + " " + IdentificationActivity.initiales_vendeur + "\n");
            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());


            mPrinter.addTextAlign(Printer.ALIGN_LEFT);
            textData.append("------------------------------------------------\n");
            textData.append(String.format("%-16s", "REF") + String.format("%-5s", "COUL") + String.format("%6s", "QTE") + String.format("%8s", "PU HT  ") + String.format("%12s", "MONTANT") + "\n");

            //12 10 10 15 = 47
            //12 10 8 8 9 = 47

            //mPrinter.addTextAlign(Printer.ALIGN_LEFT);

            String oldRef = "";

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            for (Produit p : commande.getListeProduit()) {
                textData.append("------------------------------------------------\n");
                System.out.println(getPrixTotalRef(p.getRef()));
                mPrinter.addTextStyle(0, 0, 1, 0);
                //if (p.getSiPromo() == 1 || (p.getPrix() != p.getPrixCatalogue())) {
                //    textData.append(String.format("%-16s", p.getRef()+" "+p.getNumero_de_rayon()) + String.format("%-5s", p.getColoris()) + String.format("%6s", p.getQte()) + "*" + String.format("%8s", df.format(p.getPrixPromo())) + String.format("%12s", df.format(p.getQte() * p.getPrixPromo())));
                //} else {
                textData.append(String.format("%-16s", p.getRef()+" "+p.getNumero_de_rayon()) + String.format("%-5s", p.getColoris()) + String.format("%6s", p.getQte()) + String.format("%8s", df.format((p.getPrix() * 100) / 100)+"  ") + String.format("%13s", df.format(p.getQte() * p.getPrix()))); //Ajout d'un caractère sur le prix pour ne pas avoir de tirrets par la suite
                //}
                mPrinter.addText(textData.toString());
                textData.delete(0, textData.length());
            }

            textData.delete(0, textData.length());
            mPrinter.addTextStyle(0, 0, 0, 0);
            textData.append("------------------------------------------------\n");

            if (commande.getRemiseGlobalePourcentage() > 0) {
                textData.append(String.format("%-18s", "") + String.format("%30s", "AVANT REMISE: " + df.format(commande.getPrixTotal()) + "\n"));
                textData.append("\n");
                df.setRoundingMode(RoundingMode.HALF_UP); //ARRONDI AU SUPERIEUR
                Double remise = commande.getRemiseTotal();
                textData.append(String.format("%-18s", "") + String.format("%30s", "REMISE ("+df.format(commande.getRemiseGlobalePourcentage())+"%) " + df.format(commande.getRemiseTotal()) + "\n"));
                df.setRoundingMode(RoundingMode.HALF_DOWN);
                textData.append("\n");
                textData.append(String.format("%-18s", "Qté TOTAL: " + commande.getQtetotal()) + String.format("%30s", "TOTAL HT: " + df.format(commande.getPrixTotalAvecRemise()) + "\n"));
                textData.append("\n");
            } else {
                textData.append(String.format("%-18s", "Qté TOTAL: " + commande.getQtetotal()) + String.format("%30s", "TOTAL HT: " + df.format(commande.getPrixTotal())) + "\n");
                textData.append("\n");
            }

            textData.append("TRANSPORTEUR: " + commande.getModeLivraison() + "\n");
            method = "addText";
            textData.append("\n");
            textData.append("\n");
            textData.append("Note: " + "\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            mPrinter.addText(textData.toString());


            method = "addCut";
            mPrinter.addCut(Printer.CUT_FEED);
            textData.delete(0, textData.length());
        } catch (Exception e) {
            ShowMsg.showException(e, method, mContext);
            return false;
        }
        return true;
    }

    private boolean createTicketRassemblee(String ligneProduitsRassemblee) {

        //Imprimer le ticket
        String method = "";
        Bitmap logoData = BitmapFactory.decodeResource(getResources(), R.drawable.photo_test);
        StringBuilder textData = new StringBuilder();


        Bitmap zelyx = BitmapFactory.decodeResource(getResources(), R.drawable.zelyx);
        final int barcodeWidth = 2;
        final int barcodeHeight = 64;
        final int pageAreaHeight = 500;
        final int pageAreaWidth = 500;
        final int fontAHeight = 24;
        final int fontAWidth = 12;
        final int barcodeWidthPos = 120;
        final int barcodeHeightPos = 70;


        if (mPrinter == null) {
            //return false;
        }

        try {

            //DecimalFormat df = new DecimalFormat("0.00");
            //TICKET 1
            method = "addTextAlign";
            mPrinter.addTextAlign(Printer.ALIGN_CENTER);

            mPrinter.addTextSize(1, 1);
            method = "addFeedLine";
            mPrinter.addFeedLine(1);
            textData.append("  \n");


            //method = "addImage";
            //mPrinter.addImage(zelyx, 0, 0, zelyx.getWidth(), zelyx.getHeight(), Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 3, Printer.PARAM_DEFAULT);

            textData.append("LISTE DE COLISAGE\n");
            textData.append("N°: " + numero_commande + "\n");

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());


            method = "addBarcode";

            mPrinter.addBarcode("{A" + numero_commande, Printer.BARCODE_CODE128, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 2, 64);

            textData.append("\n");

            textData.append("CLIENT:" + commande.getNomClient() + "\n");

            mPrinter.addTextAlign(Printer.ALIGN_LEFT);
            textData.append("DATE: " + commande.getDate().replace("/", "-") + "\n");

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            mPrinter.addTextAlign(Printer.ALIGN_RIGHT);
            textData.append(IdentificationActivity.code_boutique + " " + IdentificationActivity.initiales_vendeur + "\n");
            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());


            mPrinter.addTextAlign(Printer.ALIGN_LEFT);
            textData.append("------------------------------------------------\n");


            //textData.append(String.format("%-10s", "Code art.") + String.format("%-12s", "Désignation") + String.format("%-8s", "PU HT") + String.format("%-8s", "MONTANT") + "\n"); //38
            textData.append(String.format("%-10s", "CODE ART.") + String.format("%-13s", "DES.") + String.format("%6s", "QTE") + String.format("%6s", "PU HT") + String.format("%7s", "    MONTANT") + "\n");


            //12 10 10 15 = 47
            //12 10 8 8 9 = 47

            mPrinter.addTextAlign(Printer.ALIGN_LEFT);

            mPrinter.addText(textData.toString());


            textData.delete(0, textData.length());

            //Lignes produits rassemblee depuis le JSON
            textData.append(ligneProduitsRassemblee);
            //Toast.makeText(mContext, "produits: " + ligneProduitsRassemblee, Toast.LENGTH_LONG).show();
            //resultprint.setText(textData.toString());
            mPrinter.addText(textData.toString());

            textData.delete(0, textData.length());
            mPrinter.addTextStyle(0, 0, 0, 0);

            textData.append("\n");
            textData.append("TRANSPORTEUR: " + commande.getModeLivraison() + "\n");
            method = "addText";
            textData.append("\n");
            textData.append("\n");
            textData.append("Note: " + "\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            mPrinter.addText(textData.toString());


            method = "addCut";
            mPrinter.addCut(Printer.CUT_FEED);
            textData.delete(0, textData.length());
        } catch (Exception e) {
            ShowMsg.showException(e, method, mContext);
            //return false;
        }
        textData = null;
        return true;
    }

    public int getQteRef(String ref) {
        int res = 0;
        for (Produit p : commande.getListeProduit()) {
            if (p.getRef().equals(ref)) {
                res += p.getQte();
            }
        }
        return res;
    }

    private boolean runPrintCouponSequence() {
        if (!initializeObject()) {
            return false;
        }

        if (!createCouponData()) {
            finalizeObject();
            return false;
        }

        if (!printData()) {
            finalizeObject();
            return false;
        }

        return true;
    }

    private boolean createCouponData() {
        String method = "";
        Bitmap coffeeData = BitmapFactory.decodeResource(getResources(), R.drawable.photo_test);
        Bitmap wmarkData = BitmapFactory.decodeResource(getResources(), R.drawable.photo_test);

        final int barcodeWidth = 2;
        final int barcodeHeight = 64;
        final int pageAreaHeight = 500;
        final int pageAreaWidth = 500;
        final int fontAHeight = 24;
        final int fontAWidth = 12;
        final int barcodeWidthPos = 110;
        final int barcodeHeightPos = 70;

        if (mPrinter == null) {
            return false;
        }

        try {
            method = "addPageBegin";
            mPrinter.addPageBegin();

            method = "addPageArea";
            mPrinter.addPageArea(0, 0, pageAreaWidth, pageAreaHeight);

            method = "addPageDirection";
            mPrinter.addPageDirection(Printer.DIRECTION_TOP_TO_BOTTOM);

            method = "addPagePosition";
            mPrinter.addPagePosition(0, coffeeData.getHeight());

            method = "addImage";
            mPrinter.addImage(coffeeData, 0, 0, coffeeData.getWidth(), coffeeData.getHeight(), Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 3, Printer.PARAM_DEFAULT);

            method = "addPagePosition";
            mPrinter.addPagePosition(0, wmarkData.getHeight());

            method = "addImage";
            mPrinter.addImage(wmarkData, 0, 0, wmarkData.getWidth(), wmarkData.getHeight(), Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT);

            method = "addPagePosition";
            mPrinter.addPagePosition(fontAWidth * 4, (pageAreaHeight / 2) - (fontAHeight * 2));

            method = "addTextSize";
            mPrinter.addTextSize(3, 3);

            method = "addTextStyle";
            mPrinter.addTextStyle(Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.TRUE, Printer.PARAM_DEFAULT);

            method = "addTextSmooth";
            mPrinter.addTextSmooth(Printer.TRUE);

            method = "addText";
            mPrinter.addText("FREE Coffee\n");

            method = "addPagePosition";
            mPrinter.addPagePosition((pageAreaWidth / barcodeWidth) - barcodeWidthPos, coffeeData.getHeight() + barcodeHeightPos);

            method = "addBarcode";
            mPrinter.addBarcode("01234567890", Printer.BARCODE_CODE128, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, barcodeWidth, barcodeHeight);

            method = "addPageEnd";
            mPrinter.addPageEnd();

            method = "addCut";
            mPrinter.addCut(Printer.CUT_FEED);
        } catch (Exception e) {
            ShowMsg.showException(e, method, mContext);
            return false;
        }

        return true;
    }

    private boolean printData() {
        if (mPrinter == null) {
            return false;
        }

        if (!connectPrinter()) {
            return false;
        }

        PrinterStatusInfo status = mPrinter.getStatus();

        dispPrinterWarnings(status);

        if (!isPrintable(status)) {
            ShowMsg.showMsg(makeErrorMessage(status), mContext);
            try {
                mPrinter.disconnect();
            } catch (Exception ex) {
                // Do nothing
            }
            return false;
        }

        try {
            mPrinter.sendData(Printer.PARAM_DEFAULT);

        } catch (Exception e) {
            ShowMsg.showException(e, "sendData", mContext);
            try {
                mPrinter.disconnect();
            } catch (Exception ex) {
                // Do nothing
            }
            return false;
        }

        return true;
    }

    private boolean initializeObject() {
        try {
            mPrinter = new Printer(((SpnModelsItem) mSpnSeries.getSelectedItem()).getModelConstant(),
                    ((SpnModelsItem) mSpnLang.getSelectedItem()).getModelConstant(),
                    mContext);
        } catch (Exception e) {
            ShowMsg.showException(e, "Printer", mContext);
            return false;
        }

        mPrinter.setReceiveEventListener(this);

        return true;
    }

    private void finalizeObject() {
        if (mPrinter == null) {
            return;
        }

        mPrinter.clearCommandBuffer();

        mPrinter.setReceiveEventListener(null);

        mPrinter = null;
    }

    private boolean connectPrinter() {
        boolean isBeginTransaction = false;

        if (mPrinter == null) {
            return false;
        }

        try {
            mPrinter.connect(mEditTarget.getText().toString(), Printer.PARAM_DEFAULT);
        } catch (Exception e) {
            ShowMsg.showException(e, "connect", mContext);
            Toast.makeText(mContext, "Imprimante hors ligne !\n@MAC configurée: " + IdentificationActivity.mac_imprimante, Toast.LENGTH_LONG).show();
            return false;
        }

        try {
            mPrinter.beginTransaction();
            isBeginTransaction = true;
        } catch (Exception e) {
            ShowMsg.showException(e, "beginTransaction", mContext);
        }

        if (isBeginTransaction == false) {
            try {
                mPrinter.disconnect();
            } catch (Epos2Exception e) {
                // Do nothing
                return false;
            }
        }

        return true;
    }

    private void disconnectPrinter() {
        if (mPrinter == null) {
            return;
        }

        try {
            mPrinter.endTransaction();
        } catch (final Exception e) {
            runOnUiThread(new Runnable() {
                @Override
                public synchronized void run() {
                    ShowMsg.showException(e, "endTransaction", mContext);
                }
            });
        }

        try {
            mPrinter.disconnect();
        } catch (final Exception e) {
            runOnUiThread(new Runnable() {
                @Override
                public synchronized void run() {
                    ShowMsg.showException(e, "disconnect", mContext);
                }
            });
        }

        finalizeObject();
    }

    private boolean isPrintable(PrinterStatusInfo status) {
        if (status == null) {
            return false;
        }

        if (status.getConnection() == Printer.FALSE) {
            return false;
        } else if (status.getOnline() == Printer.FALSE) {
            return false;
        } else {
            //print available
        }

        return true;
    }

    private String makeErrorMessage(PrinterStatusInfo status) {
        String msg = "";

        if (status.getOnline() == Printer.FALSE) {
            msg += getString(R.string.handlingmsg_err_offline);
        }
        if (status.getConnection() == Printer.FALSE) {
            msg += getString(R.string.handlingmsg_err_no_response);
        }
        if (status.getCoverOpen() == Printer.TRUE) {
            msg += getString(R.string.handlingmsg_err_cover_open);
        }
        if (status.getPaper() == Printer.PAPER_EMPTY) {
            msg += getString(R.string.handlingmsg_err_receipt_end);
        }
        if (status.getPaperFeed() == Printer.TRUE || status.getPanelSwitch() == Printer.SWITCH_ON) {
            msg += getString(R.string.handlingmsg_err_paper_feed);
        }
        if (status.getErrorStatus() == Printer.MECHANICAL_ERR || status.getErrorStatus() == Printer.AUTOCUTTER_ERR) {
            msg += getString(R.string.handlingmsg_err_autocutter);
            msg += getString(R.string.handlingmsg_err_need_recover);
        }
        if (status.getErrorStatus() == Printer.UNRECOVER_ERR) {
            msg += getString(R.string.handlingmsg_err_unrecover);
        }
        if (status.getErrorStatus() == Printer.AUTORECOVER_ERR) {
            if (status.getAutoRecoverError() == Printer.HEAD_OVERHEAT) {
                msg += getString(R.string.handlingmsg_err_overheat);
                msg += getString(R.string.handlingmsg_err_head);
            }
            if (status.getAutoRecoverError() == Printer.MOTOR_OVERHEAT) {
                msg += getString(R.string.handlingmsg_err_overheat);
                msg += getString(R.string.handlingmsg_err_motor);
            }
            if (status.getAutoRecoverError() == Printer.BATTERY_OVERHEAT) {
                msg += getString(R.string.handlingmsg_err_overheat);
                msg += getString(R.string.handlingmsg_err_battery);
            }
            if (status.getAutoRecoverError() == Printer.WRONG_PAPER) {
                msg += getString(R.string.handlingmsg_err_wrong_paper);
            }
        }
        if (status.getBatteryLevel() == Printer.BATTERY_LEVEL_0) {
            msg += getString(R.string.handlingmsg_err_battery_real_end);
        }

        return msg;
    }

    private void dispPrinterWarnings(PrinterStatusInfo status) {
        EditText edtWarnings = findViewById(R.id.edtWarnings);
        String warningsMsg = "";

        if (status == null) {
            return;
        }

        if (status.getPaper() == Printer.PAPER_NEAR_END) {
            warningsMsg += getString(R.string.handlingmsg_warn_receipt_near_end);
        }

        if (status.getBatteryLevel() == Printer.BATTERY_LEVEL_1) {
            warningsMsg += getString(R.string.handlingmsg_warn_battery_near_end);
        }

        edtWarnings.setText(warningsMsg);
    }

    private void updateButtonState(boolean state) {
        Button btnReceipt = findViewById(R.id.btnSampleReceipt);
        Button btnCoupon = findViewById(R.id.btnSampleCoupon);
        btnReceipt.setEnabled(state);
        btnCoupon.setEnabled(state);
    }

    @Override
    public void onPtrReceive(final Printer printerObj, final int code, final PrinterStatusInfo status, final String printJobId) {
        runOnUiThread(new Runnable() {
            @Override
            public synchronized void run() {

                dispPrinterWarnings(status);

                updateButtonState(true);

                new Thread(new Runnable() {
                    @Override
                    public void run() {
                        disconnectPrinter();
                    }
                }).start();
            }
        });
    }

    private void requestRuntimePermission() {
        if (Build.VERSION.SDK_INT < Build.VERSION_CODES.M) {
            return;
        }

        int permissionStorage = ContextCompat.checkSelfPermission(this, Manifest.permission.WRITE_EXTERNAL_STORAGE);
        int permissionLocation = ContextCompat.checkSelfPermission(this, Manifest.permission.ACCESS_COARSE_LOCATION);

        List<String> requestPermissions = new ArrayList<>();

        if (permissionStorage == PackageManager.PERMISSION_DENIED) {
            requestPermissions.add(Manifest.permission.WRITE_EXTERNAL_STORAGE);
        }
        if (permissionLocation == PackageManager.PERMISSION_DENIED) {
            requestPermissions.add(Manifest.permission.ACCESS_COARSE_LOCATION);
        }

        if (!requestPermissions.isEmpty()) {
            ActivityCompat.requestPermissions(this, requestPermissions.toArray(new String[requestPermissions.size()]), REQUEST_PERMISSION);
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        if (requestCode != REQUEST_PERMISSION || grantResults.length == 0) {
            return;
        }

        List<String> requestPermissions = new ArrayList<>();

        for (int i = 0; i < permissions.length; i++) {
            if (permissions[i].equals(Manifest.permission.WRITE_EXTERNAL_STORAGE)
                    && grantResults[i] == PackageManager.PERMISSION_DENIED) {
                requestPermissions.add(permissions[i]);
            }
            if (permissions[i].equals(Manifest.permission.ACCESS_COARSE_LOCATION)
                    && grantResults[i] == PackageManager.PERMISSION_DENIED) {
                requestPermissions.add(permissions[i]);
            }
        }

        if (!requestPermissions.isEmpty()) {
            ActivityCompat.requestPermissions(this, requestPermissions.toArray(new String[requestPermissions.size()]), REQUEST_PERMISSION);
        }
    }

    private class GetTicketRassembleeDonneesAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected String doInBackground(String... params) {

            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams = new HashMap<>();
            httpParams.put("num_commande", numero_commande);
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeProduitsTicketRassemblee.php", "GET", httpParams);
            //List<Produit> produitList = new ArrayList<>();
            String ligneProduit = "";
            Double montantTotal = 0.0;
            Integer cptTotal = 0;
            String oldMarque = "";
            Double prixUnite = 0.0;
            Integer qteUnite = 0;
            try {
                int success = jsonObject.getInt("success");
                JSONArray produits;
                if (success == 1) {
                    produits = jsonObject.getJSONArray("data");
                    //Iterate through the response and populate produits list
                    DecimalFormat df = new DecimalFormat("0.00");
                    for (int i = 0; i < produits.length(); i++) { //Débute à 0 donc -1
                        //Produit p = new Produit();
                        JSONObject produit = produits.getJSONObject(i);
                        try {
                            //REQUETE SQL
                            //SELECT `zelyx_produits`.`marque`,`zelyx_produits`.`categorie`, `zelyx_produits`.`informations`, SUM(`zelyx_commandes_produits`.`quantite`) AS quantite, `zelyx_commandes_produits`.`prix` FROM `zelyx_commandes_produits`, `zelyx_produits` WHERE `zelyx_commandes_produits`.`code128_produit` AND `zelyx_produits`.`code_128` GROUP BY `zelyx_produits`.`marque`,`zelyx_produits`.`categorie`, `zelyx_commandes_produits`.`prix`

                            if (!oldMarque.equals(produit.getString("initialesMarque"))) {
                                if (produit.getString("marque").length() > 32) {
                                    ligneProduit += String.format("%-10s", produit.getString("initialesMarque")) + String.format("%-16s", produit.getString("marque").substring(0, 12)) + "\n";
                                } else {
                                    ligneProduit += String.format("%-10s", produit.getString("initialesMarque")) + String.format("%-16s", produit.getString("marque")) + "\n";
                                }
                            }
                            cptTotal += produit.getInt("quantite_produit_marque");
                            oldMarque = produit.getString("initialesMarque");

                            prixUnite = Double.parseDouble(produit.getString("prix"));
                            qteUnite = Integer.parseInt(produit.getString("quantite"));

                            //textData.append(String.format("%-18s", "CODE ART.") + String.format("%-5s", "DES.") + String.format("%-6s", "QTE") + String.format("%-6s", "PU HT") + String.format("%-12s", "MONTANT") + "\n");
                            ligneProduit += String.format("%-10s", produit.getString("code_ebp"));

                            if (produit.getString("informations").length() > 12) {
                                ligneProduit += String.format("%-13s", produit.getString("informations").substring(0,12));
                            } else {
                                ligneProduit += String.format("%-13s", produit.getString("informations"));
                            }

                            ligneProduit += String.format("%6s", produit.getString("quantite"));
                            ligneProduit += String.format("%6s", df.format(prixUnite));


                            ligneProduit += String.format("%12s", df.format(prixUnite * qteUnite));
                            ligneProduit += "\n";

                            montantTotal += prixUnite * qteUnite;
                            //cptTotal += qteUnite; //RECUPERE SUR LA LIGNE MARQUE RASSEMBLE

                        } catch (Exception e) {
                            e.printStackTrace();
                            return "Erreur création ticket: " + e;
                        }
                        ligneProduitsRassemblee += ligneProduit;
                        ligneProduitsRassembleeTotal = montantTotal;
                        ligneProduitsRassembleeTotalQte = cptTotal;
                    }
                    ligneProduit += "------------------------------------------------\n";
                    //ligneProduit += String.format("%-18s", "Total pièces: " + ligneProduitsRassembleeTotalQte) + String.format("%30s", "Total HT: " + df.format(ligneProduitsRassembleeTotal)) + "\n";

                    HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                    Map<String, String> httpParams2 = new HashMap<>();
                    httpParams2.put("num_commande", numero_commande);
                    JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                            BASE_URL + "getRemiseListeProduitsTicketRassemblee.php", "GET", httpParams2);

                    Double remiseGlobale;
                    remiseGlobale = 0.0;
                    int success2 = jsonObject.getInt("success");
                    JSONArray produits2;
                    if (success2 == 1) {
                        produits2 = jsonObject2.getJSONArray("data");
                        //Iterate through the response and populate produits list
                        for (int i = 0; i < produits2.length(); i++) {
                            JSONObject produit2 = produits2.getJSONObject(i);
                            if (produit2.getString("remiseGlobale") != null) {
                                remiseGlobale = produit2.getDouble("remiseGlobale");
                            }
                        }
                    }

                    if (commande.getRemiseGlobalePourcentage() > 0) {
                        ligneProduit += (String.format("%-18s", "") + String.format("%30s", "AVANT REMISE: " + df.format(montantTotal) + "\n"));
                        ligneProduit += ("\n");
                        df.setRoundingMode(RoundingMode.HALF_UP); //ARRONDI AU SUPERIEUR
                        Double remise = ((montantTotal*remiseGlobale)/100);
                        ligneProduit += (String.format("%-18s", "") + String.format("%30s", "REMISE ("+df.format(remiseGlobale)+"%) " + df.format(remise) + "\n"));
                        df.setRoundingMode(RoundingMode.HALF_DOWN);
                        ligneProduit += ("\n");
                        ligneProduit += (String.format("%-18s", "Qté TOTAL: " + cptTotal) + String.format("%30s", "TOTAL HT: " + df.format(montantTotal-remise) + "\n"));
                        ligneProduit += ("\n");
                    } else {
                        ligneProduit += (String.format("%-18s", "Qté TOTAL: " + cptTotal) + String.format("%30s", "TOTAL HT: " + df.format(montantTotal)) + "\n");
                        ligneProduit += ("\n");
                    }

                    return ligneProduit;
                    //Lancement de l'impression après

                } else {
                    ligneProduit = "aucun";
                    return ligneProduit;
                }
            } catch (JSONException e) {
                e.printStackTrace();
                return "" + e;
            } catch (Exception e) {
                e.printStackTrace();
                return "" + e;
            }

        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);

            //Lancement de l'impression rassemblée
            runTicketRassemblee(s);

            //Toast.makeText(mContext, "res:" + s, Toast.LENGTH_SHORT).show();
        }
    }

    private class GetCommandeAsyncTask extends AsyncTask<String, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;
        private Boolean dejaFaite = false;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected String doInBackground(String... params) {

            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams = new HashMap<>();
            httpParams.put("numero_commande", numero_commande);

            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "getCommande.php", "GET", httpParams);
            try {
                int success = jsonObject.getInt("success");

                if (success == 1) {
                    JSONObject commande = jsonObject.getJSONArray("data").getJSONObject(0);
                    if (commande.getInt("complete") == 1) {
                        dejaFaite = true;
                    } else {

                        currentControle = new Commande();
                        currentControle.setNum(commande.getString("numero_commande"));
                        currentControle.setNomClient(commande.getString("nom_client"));
                        currentControle.setDate(commande.getString("date_commande"));
                        currentControle.setQtetotal(0);
                        currentControle.setPrixTotal(0);
                        currentControle.setModeLivraison(commande.getString("mode_livraison"));


                        //recuperation des produits de la commande
                        HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                        Map<String, String> httpParams2 = new HashMap<>();
                        httpParams2.put("num_commande", numero_commande);
                        JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                                BASE_URL + "listeProduitsTicketRassemble.php", "GET", httpParams2);

                        List<Produit> produitList = new ArrayList<>();

                        try {
                            int success2 = jsonObject2.getInt("success");
                            JSONArray produits;
                            if (success2 == 1) {
                                produits = jsonObject2.getJSONArray("data");
                                //Iterate through the response and populate produits list
                                for (int i = 0; i < produits.length(); i++) {
                                    Produit p = new Produit();
                                    JSONObject produit = produits.getJSONObject(i);

                                    try {
                                        p.setRef(produit.getString("reference"));
                                        p.setColoris(produit.getString("coloris"));
                                        p.setCommandable(produit.getString("commandable"));
                                        p.setCode128(produit.getString("code_128"));
                                        p.setQuantite_pack(produit.getInt("quantite_packs"));
                                        p.setPrix(produit.getDouble("prix"));
                                        p.setStock(produit.getInt("stock"));
                                        p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                                        p.setInformations(produit.getString("informations"));
                                        p.setLien_image(produit.getString("lien_image"));
                                        p.setActif(produit.getInt("actif"));
                                        p.setQte(produit.getInt("quantite"));
                                        p.setNbrScanner(0);
                                        produitList.add(p);
                                    } catch (Exception e) {
                                        e.printStackTrace();
                                    }
                                }
                                try {
                                    currentControle.setListeProduit(produitList);
                                    listeControle.set(0, currentControle);

                                    Collections.sort(currentControle.getListeProduit());
                                    listeDeListeAScanner.set(0, currentControle.getListeProduit());

                                } catch (Exception e) {
                                    e.printStackTrace();
                                }

                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (currentControle == null) {
                if (dejaFaite == true) {
                    AlertDialog.Builder alertDialog = new AlertDialog.Builder(PrinterActivity.this);
                    alertDialog.setMessage("Cette commande a déjà été contrôlée.");
                    alertDialog.setPositiveButton("OK", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int whichButton) {
                            dialog.dismiss();
                        }
                    });
                    //alertDialog.show();
                }
                //afficheVide();
                //Récupérer la liste des produits depuis le JSON
                //new GetTicketRassembleeDonneesAsyncTask().execute();
            } else {
                //afficheControle();
                //new GetTicketRassembleeDonneesAsyncTask().execute();
            }
        }
    }
}
