package fr.itsee.zelyx;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.widget.Button;
import android.widget.Toast;

import com.epson.epos2.Epos2Exception;
import com.epson.epos2.printer.Printer;
import com.epson.epos2.printer.PrinterStatusInfo;
import com.epson.epos2.printer.ReceiveListener;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class PrinterAsync extends Activity implements ReceiveListener {

    private static final int REQUEST_PERMISSION = 100;
    public static Commande currentControle;
    public static List<Produit> currentListeAScanner;
    List<Commande> listeControle = new ArrayList<>(1);
    List<List<Produit>> listeDeListeAScanner = new ArrayList<>(1);
    private Commande commande;
    private Context mContext = null;
    private com.epson.epos2.printer.Printer mPrinter = null;
    private String type_ticket, numero_commande;
    private List<Produit> listeVide;

    private String ligneProduitsRassemblee = "";
    private Double ligneProduitsRassembleeTotal = 0.0;
    private Integer ligneProduitsRassembleeTotalQte = 0;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        requestRuntimePermission();

        mContext = this;

        Intent intent = getIntent();
        commande = intent.getParcelableExtra("commande");
        Collections.sort(commande.getListeProduit());

        try {
            runPrintReceiptSequence();
        } catch (Exception e) {
            ShowMsg.showException(e, "setLogSettings", mContext);
        }

        //ITSEE Ferme la vue après impression
        finish();
    }

    private boolean runTicketDetaille() {
        if (!initializeObject()) {
            return false;
        }

        if (!createTicketDetaille()) {
            finalizeObject();
            return false;
        }

        if (!printData()) {
            finalizeObject();
            return false;
        }

        return true;
    }

    private boolean createTicketDetaille() {

        String method = "";
        Bitmap logoData = BitmapFactory.decodeResource(getResources(), R.drawable.photo_test);
        StringBuilder textData = new StringBuilder();


        Bitmap zelyx = BitmapFactory.decodeResource(getResources(), R.drawable.zelyx);
        final int barcodeWidth = 2;
        final int barcodeHeight = 64;
        final int pageAreaHeight = 500;
        final int pageAreaWidth = 500;
        final int fontAHeight = 24;
        final int fontAWidth = 12;
        final int barcodeWidthPos = 120;
        final int barcodeHeightPos = 70;


        if (mPrinter == null) {
            return false;
        }

        try {

            //TICKET 1
            method = "addTextAlign";
            mPrinter.addTextAlign(Printer.ALIGN_CENTER);

            mPrinter.addTextSize(1, 1);
            method = "addFeedLine";
            mPrinter.addFeedLine(1);
            textData.append("  \n");


            method = "addImage";
            mPrinter.addImage(zelyx, 0, 0, zelyx.getWidth(), zelyx.getHeight(), Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 3, Printer.PARAM_DEFAULT);

            textData.append("COMMANDE\n");
            textData.append("CLIENT: " + commande.getNomClient() + "\n");

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());


            method = "addBarcode";

            mPrinter.addBarcode("{A" + commande.getNum(), Printer.BARCODE_CODE128, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 2, 64);

            textData.append("\n");


            textData.append("Date: " + commande.getDate() + "   n°" + commande.getNum() + "\n");
            textData.append("------------------------------------------------\n");


            textData.append(String.format("%-9s", "Dés.") + String.format("%-11s", "Réf.") + String.format("%-5s", "Qté") + String.format("%-7s", "P.U.") + String.format("%-6s", "Montant") + "\n");

            //12 10 10 15 = 47
            //12 10 8 8 9 = 47

            mPrinter.addTextAlign(Printer.ALIGN_LEFT);

            String oldRef = "";

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());
            for (Produit p : commande.getListeProduit()) {
                textData.append("________________________________________________\n");
                //System.out.println(getPrixTotalRef(p.getRef()));
                mPrinter.addTextStyle(0, 0, 1, 0);
                //if (p.getSiPromo() == 1) {
                //    textData.append(String.format("%-9s", p.getInformations().substring(0, 9)) + String.format("%-11s", p.getRef() + " " + p.getColoris()) + String.format("%-5s", p.getQte()) + String.format("%-7s", p.getPrix()) + String.format("%-6s", p.getQte() * p.getPrix()));
                //} else {
                textData.append(String.format("%-9s", p.getInformations().substring(0, 9)) + String.format("%-11s", p.getRef() + " " + p.getColoris()) + String.format("%-5s", p.getQte()) + String.format("%-7s", "*" + p.getPrix()) + String.format("%-6s", p.getQte() * p.getPrix()));
                //}
                mPrinter.addText(textData.toString());
                textData.delete(0, textData.length());

                mPrinter.addTextStyle(0, 0, 0, 0);
                textData.append(String.format("%-12s", p.getColoris()) + String.format("%-10s", p.getQte() + "     " + p.getNumero_de_rayon()) + "\n");
                mPrinter.addText(textData.toString());
                textData.delete(0, textData.length());
            }


            textData.delete(0, textData.length());
            mPrinter.addTextStyle(0, 0, 0, 0);

            textData.append("------------------------------------------------\n");

            textData.append(String.format("%-18s", "Total pièces: " + commande.getQtetotal()) + String.format("%30s", "Total HT: " + commande.getPrixTotal()) + "\n");
            textData.append("\n");
            textData.append("Mode de transport: " + commande.getModeLivraison() + "\n");
            method = "addText";
            textData.append("\n");
            textData.append("\n");
            textData.append("Note: " + "\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            mPrinter.addText(textData.toString());

            method = "addCut";
            mPrinter.addCut(Printer.CUT_FEED);
            textData.delete(0, textData.length());

        } catch (Exception e) {
//            ShowMsg.showException(e, method, mContext);
            return false;
        }
        textData = null;
        return true;
    }

    private boolean createTicketRassemblee() {

        //Récupérer la liste des produits depuis le JSON
        new GetTicketRassembleeDonneesAsyncTask().execute();

        String method = "";
        Bitmap logoData = BitmapFactory.decodeResource(getResources(), R.drawable.photo_test);
        StringBuilder textData = new StringBuilder();


        Bitmap zelyx = BitmapFactory.decodeResource(getResources(), R.drawable.zelyx);
        final int barcodeWidth = 2;
        final int barcodeHeight = 64;
        final int pageAreaHeight = 500;
        final int pageAreaWidth = 500;
        final int fontAHeight = 24;
        final int fontAWidth = 12;
        final int barcodeWidthPos = 120;
        final int barcodeHeightPos = 70;


        if (mPrinter == null) {
            return false;
        }

        try {

            //TICKET 1
            method = "addTextAlign";
            mPrinter.addTextAlign(Printer.ALIGN_CENTER);

            mPrinter.addTextSize(1, 1);
            method = "addFeedLine";
            mPrinter.addFeedLine(1);
            textData.append("  \n");


            method = "addImage";
            mPrinter.addImage(zelyx, 0, 0, zelyx.getWidth(), zelyx.getHeight(), Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 3, Printer.PARAM_DEFAULT);

            textData.append("COMMANDE\n");
            textData.append("CLIENT: " + commande.getNomClient() + "\n");

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());


            method = "addBarcode";

            mPrinter.addBarcode("{A" + commande.getNum(), Printer.BARCODE_CODE128, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 2, 64);

            textData.append("\n");


            textData.append("Date: " + commande.getDate() + "   n°" + commande.getNum() + "\n");
            textData.append("------------------------------------------------\n");


            textData.append(String.format("%-10s", "Code art.") + String.format("%-12s", "Désignation") + String.format("%-8s", "PU HT") + String.format("%-8s", "MONTANT") + "\n"); //38

            //12 10 10 15 = 47
            //12 10 8 8 9 = 47

            mPrinter.addTextAlign(Printer.ALIGN_LEFT);

            String oldRef = "";

            mPrinter.addText(textData.toString());


            textData.delete(0, textData.length());

            //Lignes produits rassemblee depuis le JSON
            textData.append(ligneProduitsRassemblee);

            textData.delete(0, textData.length());
            mPrinter.addTextStyle(0, 0, 0, 0);

            textData.append("------------------------------------------------\n");

            textData.append(String.format("%-18s", "Total pièces: " + ligneProduitsRassembleeTotalQte) + String.format("%30s", "Total HT: " + ligneProduitsRassembleeTotal) + "\n");
            textData.append("\n");
            textData.append("Mode de transport: " + commande.getModeLivraison() + "\n");
            method = "addText";
            textData.append("\n");
            textData.append("\n");
            textData.append("Note: " + "\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            mPrinter.addText(textData.toString());


            method = "addCut";
            mPrinter.addCut(Printer.CUT_FEED);
            textData.delete(0, textData.length());
        } catch (Exception e) {
            ShowMsg.showException(e, method, mContext);
            return false;
        }
        textData = null;
        return true;
    }

    private boolean runTicketRassemblee() {
        if (!initializeObject()) {
            return false;
        }

        if (!createTicketRassemblee()) {
            finalizeObject();
            return false;
        }

        if (!printData()) {
            finalizeObject();
            return false;
        }

        return true;
    }

    @Override
    protected void onActivityResult(int requestCode, final int resultCode, final Intent data) {

    }

    private boolean runPrintReceiptSequence() {
        if (!initializeObject()) {
            return false;
        }

        if (!createReceiptData()) {
            finalizeObject();
            return false;
        }

        if (!printData()) {
            finalizeObject();
            return false;
        }

        return true;
    }

    public double getPrixTotalRef(String ref) {
        double tot = 0;
        for (Produit p : commande.getListeProduit()) {
            if (p.getRef().equals(ref)) {
                tot += p.getPrix() * p.getQuantite_pack() * p.getQte();
            }
        }
        return tot;
    }

    private boolean createReceiptData() {

        StringBuilder textData = new StringBuilder();


        Bitmap zelyx = BitmapFactory.decodeResource(getResources(), R.drawable.zelyx);

        if (mPrinter == null) {
            return false;
        }

        try {

            //TICKET 1
            mPrinter.addTextAlign(com.epson.epos2.printer.Printer.ALIGN_CENTER);

            mPrinter.addTextSize(1, 1);
            mPrinter.addFeedLine(1);
            textData.append("  \n");


            mPrinter.addImage(zelyx, 0, 0, zelyx.getWidth(), zelyx.getHeight(), com.epson.epos2.printer.Printer.PARAM_DEFAULT, com.epson.epos2.printer.Printer.PARAM_DEFAULT, com.epson.epos2.printer.Printer.PARAM_DEFAULT, 3, com.epson.epos2.printer.Printer.PARAM_DEFAULT);

            textData.append("LISTE DE COLISAGE\n");
            textData.append("CLIENT: " + commande.getNomClient() + "\n");

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());


            mPrinter.addBarcode("{A" + commande.getNum(), com.epson.epos2.printer.Printer.BARCODE_CODE128, com.epson.epos2.printer.Printer.PARAM_DEFAULT, com.epson.epos2.printer.Printer.PARAM_DEFAULT, 2, 64);

            textData.append("\n");


            textData.append("DATE: " + commande.getDate() + "   N°" + commande.getNum() + "\n");
            textData.append("------------------------------------------------\n");


            textData.append(String.format("%-12s", "REF") + String.format("%-10s", "Qté") + String.format("%-10s", "PU HT") + String.format("%-15s", "MONTANT") + "\n");

            //12 10 10 15 = 47
            //12 10 8 8 9 = 47

            mPrinter.addTextAlign(com.epson.epos2.printer.Printer.ALIGN_LEFT);

            String oldRef = "";

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());
            for (Produit p : commande.getListeProduit()) {
                if (oldRef.equals(p.getRef())) {
                    //if (p.getStock() - p.getQte() <= 2) {
                    //    mPrinter.addTextStyle(0, 0, 0, 0);
                    //    textData.append(String.format("%-12s", p.getColoris()) + String.format("%-10s", p.getQte() + "*    " + p.getNumero_de_rayon()) + "\n");
                    //    mPrinter.addText(textData.toString());
                    //    textData.delete(0, textData.length());
                    //} else {
                    //SUPPRESSION DE L'ETOILE SUR LA QUANTITE
                    mPrinter.addTextStyle(0, 0, 0, 0);
                    textData.append(String.format("%-12s", p.getColoris()) + String.format("%-10s", p.getQte() + "     " + p.getNumero_de_rayon()) + "\n");
                    mPrinter.addText(textData.toString());
                    textData.delete(0, textData.length());
                    //}
                } else {
                    textData.append("________________________________________________\n");
                    System.out.println(getPrixTotalRef(p.getRef()));
                    mPrinter.addTextStyle(0, 0, 1, 0);
                    textData.append(String.format("%-12s", p.getRef()) + String.format("%-10s", getQteRef(p.getRef()) + "X" + p.getQuantite_pack() + "pcs") + String.format("%-10s", p.getPrix()) + String.format("%-15s", getPrixTotalRef(p.getRef())) + "\n");
                    mPrinter.addText(textData.toString());
                    textData.delete(0, textData.length());

                    //if (p.getStock() - p.getQte() <= 2) {
                    //    mPrinter.addTextStyle(0, 0, 0, 0);
                    //    textData.append(String.format("%-12s", p.getColoris()) + String.format("%-10s", p.getQte() + "*    " + p.getNumero_de_rayon()) + "\n");
                    //    mPrinter.addText(textData.toString());
                    //    textData.delete(0, textData.length());
                    //} else {
                    //SUPPRESION DE L'ETOILE SUR LA QUANTITE
                    mPrinter.addTextStyle(0, 0, 0, 0);
                    textData.append(String.format("%-12s", p.getColoris()) + String.format("%-10s", p.getQte() + "     " + p.getNumero_de_rayon()) + "\n");
                    mPrinter.addText(textData.toString());
                    textData.delete(0, textData.length());
                    //}
                }
                oldRef = p.getRef();
            }


            textData.delete(0, textData.length());
            mPrinter.addTextStyle(0, 0, 0, 0);

            textData.append("------------------------------------------------\n");

            textData.append(String.format("%-18s", "Qté TOTAL: " + commande.getQtetotal()) + String.format("%30s", "TOTAL HT: " + commande.getPrixTotal()) + "\n");
            textData.append("\n");
            textData.append("TRANSPORTEUR: " + commande.getModeLivraison() + "\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            mPrinter.addText(textData.toString());

            mPrinter.addCut(com.epson.epos2.printer.Printer.CUT_FEED);
            textData.delete(0, textData.length());

        } catch (Exception e) {
            //ShowMsg.showException(e, method, mContext);
            return false;
        }
        return true;
    }

    public int getQteRef(String ref) {
        int res = 0;
        for (Produit p : commande.getListeProduit()) {
            if (p.getRef().equals(ref)) {
                res += p.getQte();
            }
        }
        return res;
    }

    private boolean printData() {
        if (mPrinter == null) {
            return false;
        }

        if (!connectPrinter()) {
            return false;
        }

        PrinterStatusInfo status = mPrinter.getStatus();

        dispPrinterWarnings(status);

        if (!isPrintable(status)) {
            try {
                mPrinter.disconnect();
            } catch (Exception ex) {
                // Do nothing
            }
            return false;
        }

        try {
            mPrinter.sendData(com.epson.epos2.printer.Printer.PARAM_DEFAULT);

        } catch (Exception e) {
            try {
                mPrinter.disconnect();
            } catch (Exception ex) {
                // Do nothing
            }
            return false;
        }

        return true;
    }

    private boolean initializeObject() {
        try {
            //CONFIGURATION Modèle Tm-m30 et FRANCAIS
            mPrinter = new Printer(com.epson.epos2.printer.Printer.TM_M30, com.epson.epos2.printer.Printer.MODEL_ANK, mContext);

        } catch (Exception e) {
            return false;
        }

        mPrinter.setReceiveEventListener(this);

        return true;
    }

    private void finalizeObject() {
        if (mPrinter == null) {
            return;
        }

        mPrinter.clearCommandBuffer();

        mPrinter.setReceiveEventListener(null);

        mPrinter = null;
    }

    private boolean connectPrinter() {
        boolean isBeginTransaction = false;

        if (mPrinter == null) {
            return false;
        }

        try {
            //CONFIGURATION TCP IMPRIMANTE
            mPrinter.connect("TCP:" + IdentificationActivity.mac_imprimante, com.epson.epos2.printer.Printer.PARAM_DEFAULT);
        } catch (Exception e) {

            ShowMsg.showException(e, "connect", mContext);
            return false;
        }

        try {
            mPrinter.beginTransaction();
            isBeginTransaction = true;
        } catch (Exception e) {
        }

        if (isBeginTransaction == false) {
            try {
                mPrinter.disconnect();
            } catch (Epos2Exception e) {
                // Do nothing
                return false;
            }
        }

        return true;
    }

    private void disconnectPrinter() {
        if (mPrinter == null) {
            return;
        }

        try {
            mPrinter.endTransaction();
        } catch (final Exception e) {
        }

        try {
            mPrinter.disconnect();
        } catch (final Exception e) {
        }

        finalizeObject();
    }

    private boolean isPrintable(PrinterStatusInfo status) {
        if (status == null) {
            return false;
        }

        if (status.getConnection() == com.epson.epos2.printer.Printer.FALSE) {
            return false;
        } else if (status.getOnline() == com.epson.epos2.printer.Printer.FALSE) {
            return false;
        } else {
            //print available
        }

        return true;
    }

    private void dispPrinterWarnings(PrinterStatusInfo status) {
        String warningsMsg = "";

        if (status == null) {
            return;
        }

        if (status.getPaper() == com.epson.epos2.printer.Printer.PAPER_NEAR_END) {
            warningsMsg += getString(R.string.handlingmsg_warn_receipt_near_end);
        }

        if (status.getBatteryLevel() == com.epson.epos2.printer.Printer.BATTERY_LEVEL_1) {
            warningsMsg += getString(R.string.handlingmsg_warn_battery_near_end);
        }

        Toast.makeText(getApplicationContext(), warningsMsg, Toast.LENGTH_LONG).show();
    }

    private void updateButtonState(boolean state) {
        Button btnReceipt = findViewById(R.id.btnSampleReceipt);
        Button btnCoupon = findViewById(R.id.btnSampleCoupon);
        btnReceipt.setEnabled(state);
        btnCoupon.setEnabled(state);
    }

    @Override
    public void onPtrReceive(final com.epson.epos2.printer.Printer printerObj, final int code, final PrinterStatusInfo status, final String printJobId) {
        runOnUiThread(new Runnable() {
            @Override
            public synchronized void run() {

                dispPrinterWarnings(status);

                updateButtonState(true);

                new Thread(new Runnable() {
                    @Override
                    public void run() {
                        disconnectPrinter();
                    }
                }).start();
            }
        });
    }

    private void requestRuntimePermission() {
        if (Build.VERSION.SDK_INT < Build.VERSION_CODES.M) {
            return;
        }

        int permissionStorage = ContextCompat.checkSelfPermission(this, Manifest.permission.WRITE_EXTERNAL_STORAGE);
        int permissionLocation = ContextCompat.checkSelfPermission(this, Manifest.permission.ACCESS_COARSE_LOCATION);

        List<String> requestPermissions = new ArrayList<>();

        if (permissionStorage == PackageManager.PERMISSION_DENIED) {
            requestPermissions.add(Manifest.permission.WRITE_EXTERNAL_STORAGE);
        }
        if (permissionLocation == PackageManager.PERMISSION_DENIED) {
            requestPermissions.add(Manifest.permission.ACCESS_COARSE_LOCATION);
        }

        if (!requestPermissions.isEmpty()) {
            ActivityCompat.requestPermissions(this, requestPermissions.toArray(new String[requestPermissions.size()]), REQUEST_PERMISSION);
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        if (requestCode != REQUEST_PERMISSION || grantResults.length == 0) {
            return;
        }

        List<String> requestPermissions = new ArrayList<>();

        for (int i = 0; i < permissions.length; i++) {
            if (permissions[i].equals(Manifest.permission.WRITE_EXTERNAL_STORAGE)
                    && grantResults[i] == PackageManager.PERMISSION_DENIED) {
                requestPermissions.add(permissions[i]);
            }
            if (permissions[i].equals(Manifest.permission.ACCESS_COARSE_LOCATION)
                    && grantResults[i] == PackageManager.PERMISSION_DENIED) {
                requestPermissions.add(permissions[i]);
            }
        }

        if (!requestPermissions.isEmpty()) {
            ActivityCompat.requestPermissions(this, requestPermissions.toArray(new String[requestPermissions.size()]), REQUEST_PERMISSION);
        }
    }

    private class PrinterAsyncTask extends AsyncTask<Produit, String, String> {

        private int success;

        @Override
        protected String doInBackground(Produit... produits) {

            try {
                runPrintReceiptSequence();
            } catch (Exception e) {
                ShowMsg.showException(e, "setLogSettings", mContext);
            }

            Intent intent = getIntent();
            commande = intent.getParcelableExtra("commande");
            Collections.sort(commande.getListeProduit());

            type_ticket = intent.getParcelableExtra("commande");

            numero_commande = commande.getNum();

            Collections.sort(commande.getListeProduit());

            //Si Ticket "détaillé"
            if (type_ticket == "detaillee") {
                runTicketDetaille();
            } else if (type_ticket == "rassemblee") {
                runTicketRassemblee();
            }

            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
        }
    }

    private class GetCommandeAsyncTask extends AsyncTask<String, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;
        private Boolean dejaFaite = false;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected String doInBackground(String... params) {

            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams = new HashMap<>();
            httpParams.put("numero_commande", numero_commande);

            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "getCommande.php", "GET", httpParams);
            try {
                int success = jsonObject.getInt("success");

                if (success == 1) {
                    JSONObject commande = jsonObject.getJSONArray("data").getJSONObject(0);
                    if (commande.getInt("complete") == 1) {
                        dejaFaite = true;
                    } else {

                        currentControle = new Commande();
                        currentControle.setNum(commande.getString("numero_commande"));
                        currentControle.setNomClient(commande.getString("nom_client"));
                        currentControle.setDate(commande.getString("date_commande"));
                        currentControle.setQtetotal(0);
                        currentControle.setPrixTotal(0);
                        currentControle.setModeLivraison(commande.getString("mode_livraison"));


                        //recuperation des produits de la commande
                        HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                        Map<String, String> httpParams2 = new HashMap<>();
                        httpParams2.put("num_commande", numero_commande);
                        JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                                BASE_URL + "listeProduitsTicketRassemble.php", "GET", httpParams2);

                        List<Produit> produitList = new ArrayList<>();

                        try {
                            int success2 = jsonObject2.getInt("success");
                            JSONArray produits;
                            if (success2 == 1) {
                                produits = jsonObject2.getJSONArray("data");
                                //Iterate through the response and populate produits list
                                for (int i = 0; i < produits.length(); i++) {
                                    Produit p = new Produit();
                                    JSONObject produit = produits.getJSONObject(i);
                                    try {
                                        p.setRef(produit.getString("reference"));
                                        p.setColoris(produit.getString("coloris"));
                                        p.setCommandable(produit.getString("commandable"));
                                        p.setCode128(produit.getString("code_128"));
                                        p.setQuantite_pack(produit.getInt("quantite_packs"));
                                        p.setPrix(produit.getDouble("prix"));
                                        p.setStock(produit.getInt("stock"));
                                        p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                                        p.setInformations(produit.getString("informations"));
                                        p.setLien_image(produit.getString("lien_image"));
                                        p.setActif(produit.getInt("actif"));
                                        p.setQte(produit.getInt("quantite"));
                                        p.setNbrScanner(0);
                                        produitList.add(p);
                                    } catch (Exception e) {
                                        e.printStackTrace();
                                    }
                                }
                                try {
                                    currentControle.setListeProduit(produitList);
                                    listeControle.set(0, currentControle);

                                    Collections.sort(currentControle.getListeProduit());
                                    listeDeListeAScanner.set(0, currentControle.getListeProduit());

                                } catch (Exception e) {
                                    e.printStackTrace();
                                }
                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (currentControle == null) {
                if (dejaFaite == true) {
                    AlertDialog.Builder alertDialog = new AlertDialog.Builder(PrinterAsync.this);
                    alertDialog.setMessage("Cette commande a déjà été contrôlée.");
                    alertDialog.setPositiveButton("OK", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int whichButton) {
                            dialog.dismiss();
                        }
                    });
                    alertDialog.show();
                }
                //afficheVide();
            } else {
                //afficheControle();
            }
        }
    }

    /* Récupérer les informations pour générer le ticket rassemblee */
    //BASE DE DONNES
    private class GetTicketRassembleeDonneesAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeProduitsTicketRassemblee.php", "GET", null);
            List<Produit> produitList = new ArrayList<>();
            String ligneProduit = "";
            Double montantTotal = 0.0;
            Integer cptTotal = 0;
            String oldMarque = "";
            try {
                int success = jsonObject.getInt("success");
                JSONArray produits;
                if (success == 1) {
                    produits = jsonObject.getJSONArray("data");
                    //Iterate through the response and populate produits list
                    for (int i = 0; i < produits.length(); i++) {
                        //Produit p = new Produit();
                        JSONObject produit = produits.getJSONObject(i);

                        try {
                            //REQUETE SQL
                            //SELECT `zelyx_produits`.`marque`,`zelyx_produits`.`categorie`, `zelyx_produits`.`informations`, SUM(`zelyx_commandes_produits`.`quantite`) AS quantite, `zelyx_commandes_produits`.`prix` FROM `zelyx_commandes_produits`, `zelyx_produits` WHERE `zelyx_commandes_produits`.`code128_produit` AND `zelyx_produits`.`code_128` GROUP BY `zelyx_produits`.`marque`,`zelyx_produits`.`categorie`, `zelyx_commandes_produits`.`prix`

                            //Créer les lignes de produits
                            //Catégorie article
                            //Désignation
                            //Quantité
                            //Prix unitaire

                            //Montant calculé dans le ticket
                            if (oldMarque != produit.getString("marque")) {
                                ligneProduit += String.format("%-7s", "") + String.format("%-31s", produit.getString("marque").substring(0, 31)) + "\n";
                            }
                            //Ligne produit
                            ligneProduit += String.format("%-10s", produit.getString("categorie").substring(0, 10)) + String.format("%-12s", produit.getString("informations").substring(0, 12)) + String.format("%-8s", produit.getString("quantite")) + String.format("%-8s", Integer.parseInt(produit.getString("quantite")) * Double.parseDouble(produit.getString("prix"))) + "\n";

                            montantTotal += Double.parseDouble(produit.getString("prix")) * Integer.parseInt(produit.getString("quantite"));
                            cptTotal += Integer.parseInt(produit.getString("quantite"));

                        } catch (Exception e) {
                            e.printStackTrace();
                        }

                    }
                    //Lancer l'impression
                    ligneProduitsRassemblee = ligneProduit;
                    ligneProduitsRassembleeTotal = montantTotal;
                    ligneProduitsRassembleeTotalQte = cptTotal;

                }
            } catch (JSONException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            //Lance l'impression
            //runTicketRassemblee();

        }
    }
}
