package fr.itsee.zelyx;

import android.os.Parcel;
import android.os.Parcelable;

import java.util.Comparator;

public class Produit implements Parcelable, Comparable<Produit> {

    private String ref;
    private String coloris;
    private String commandable;
    private String code_128;
    private int quantite_packs;
    private double prix;
    private double prix_promo;
    private double prix_catalogue;
    private int stock;
    private String numero_de_rayon;
    private String informations;
    private String lien_image;
    private int actif;
    private int qte;
    private int nbrScanner;
    private int qte_total_ref;
    private int si_promo;
    private String num_categorie;
    private int seuil_min, seuil_max;

    public Produit() {

    }

    public Produit(Produit p) {
        this.ref = p.getRef();
        this.coloris = p.getColoris();
        this.commandable = p.getCommandable();
        this.code_128 = p.getCode128();
        this.quantite_packs = p.getQuantite_pack();
        this.prix = p.getPrix();
        this.stock = p.getStock();
        this.numero_de_rayon = p.getNumero_de_rayon();
        this.informations = p.getInformations();
        this.lien_image = p.getLien_image();
        this.actif = p.getActif();
        this.qte = p.getQte();
        this.nbrScanner = p.getNbrScanner();
        this.qte_total_ref = p.getQteTotalRef();
        this.prix_promo = p.getPrixPromo();
        this.si_promo = p.getSiPromo();
        this.num_categorie = p.getNumCategorie();
        this.seuil_min = p.getSeuilMin();
        this.seuil_min = p.getSeuilMax();
        this.prix_catalogue = p.getPrixCatalogue();
    }


    protected Produit(Parcel in) {
        ref = in.readString();
        coloris = in.readString();
        commandable = in.readString();
        code_128 = in.readString();
        quantite_packs = in.readInt();
        prix = in.readDouble();
        stock = in.readInt();
        numero_de_rayon = in.readString();
        informations = in.readString();
        lien_image = in.readString();
        actif = in.readInt();
        qte = in.readInt();
        nbrScanner = in.readInt();
        qte_total_ref = in.readInt();
        prix_promo = in.readDouble();
        si_promo = in.readInt();
        num_categorie = in.readString();
        seuil_min = in.readInt();
        seuil_max = in.readInt();
        prix_catalogue = in.readDouble();
    }

    public static final Creator<Produit> CREATOR = new Creator<Produit>() {
        @Override
        public Produit createFromParcel(Parcel in) {
            return new Produit(in);
        }

        @Override
        public Produit[] newArray(int size) {
            return new Produit[size];
        }
    };

    @Override
    public int compareTo(Produit produit) {
        return this.getCode128().compareTo(produit.getCode128());
    }

    public class code128CompareTo implements Comparator<Produit> {
        public int compare(Produit left, Produit right) {
            return left.code_128.compareTo(right.code_128);
        }
    }

    public int getNbrScanner() {
        return nbrScanner;
    }

    public void setNbrScanner(int nbrScanner) {
        this.nbrScanner = nbrScanner;
    }

    public void setQteTotalRef(int qte_total_ref) {
        this.qte_total_ref = qte_total_ref;
    }

    public String getColoris() {
        return coloris;
    }

    public String getRef() {
        return ref;
    }

    public double getPrix() {
        return prix;
    }

    public double getPrixCatalogue() {
        return prix_catalogue;
    }

    public double getPrixPromo() {
        return prix_promo;
    }

    public int getSiPromo() {
        return si_promo;
    }

    public int getSeuilMin() {
        return seuil_min;
    }

    public int getSeuilMax() {
        return seuil_max;
    }

    public void setSeuilMin(Integer seuil_min) {
        this.seuil_min = seuil_min;
    }

    public void setSeuilMax(Integer seuil_max) {
        this.seuil_max = seuil_max;
    }


    public void setNumCategorie(String num_categorie) {
        this.num_categorie = num_categorie;
    }

    public String getNumCategorie() {
        return num_categorie;
    }

    public double getPrixTotale() {
        return (double) Math.round((prix * qte) * 100d) / 100d;
    }

    public double getPrixTotaleUnite() {
       return (double) Math.round((prix * qte) * 100d) / 100d;
    }

    public int getQte() {
        return qte;
    }

    public int getQteTotalRef() {
        return qte_total_ref;
    }

    public void setColoris(String coloris) {
        this.coloris = coloris;
    }

    public void setRef(String ref) {
        this.ref = ref;
    }

    public void setPrix(double prix) {
        this.prix = prix;
    }

    public void setPrixCatalogue(double prix_catalogue) { this.prix_catalogue = prix_catalogue; }

    public void setPrixPromo(double prix_promo) {
        this.prix_promo = prix_promo;
    }

    public void setSiPromo(int si_promo) {
        this.si_promo = si_promo;
    }

    public void setQte(int qte) {
        this.qte = qte;
    }

    public int getActif() {
        return actif;
    }

    public String getCommandable() {
        return commandable;
    }

    public String getNumero_de_rayon() {
        return numero_de_rayon;
    }

    public int getStock() {
        return stock;
    }

    public int getQuantite_pack() {
        return quantite_packs;
    }

    public String getCode128() {
        return code_128;
    }

    public String getInformations() {
        return informations;
    }

    public String getLien_image() {
        return lien_image;
    }

    public void setActif(int actif) {
        this.actif = actif;
    }

    public void setCode128(String code_128) {
        this.code_128 = code_128;
    }

    public void setCommandable(String commandable) {
        this.commandable = commandable;
    }

    public void setInformations(String informations) {
        this.informations = informations;
    }

    public void setLien_image(String lien_image) {
        this.lien_image = lien_image;
    }

    public void setNumero_de_rayon(String numero_de_rayon) {
        this.numero_de_rayon = numero_de_rayon;
    }

    public void setQuantite_pack(int quantite_packs) {
        this.quantite_packs = quantite_packs;
    }

    public void setStock(int stock) {
        this.stock = stock;
    }

    public void incQte() {
        this.qte += 1;
    }

    public void decQte() {
        this.qte -= 1;
    }

    @Override
    public String toString() {
        return "" + code_128 + ": qte:" + qte + "stock: " + stock;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeString(ref);
        parcel.writeString(coloris);
        parcel.writeString(commandable);
        parcel.writeString(code_128);
        parcel.writeInt(quantite_packs);
        parcel.writeDouble(prix);
        parcel.writeInt(stock);
        parcel.writeString(numero_de_rayon);
        parcel.writeString(informations);
        parcel.writeString(lien_image);
        parcel.writeInt(actif);
        parcel.writeInt(qte);
        parcel.writeInt(nbrScanner);
        parcel.writeInt(qte_total_ref);
        parcel.writeDouble(prix_promo);
        parcel.writeInt(si_promo);
        parcel.writeString(num_categorie);
        parcel.writeInt(seuil_min);
        parcel.writeInt(seuil_max);
        parcel.writeDouble(prix_catalogue);
    }
}
